/* gpaste-client.c generated by valac 0.16.0, the Vala compiler
 * generated from gpaste-client.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011-2012 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define G_PASTE_TYPE_DBUS_CLIENT (g_paste_dbus_client_get_type ())
#define G_PASTE_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_DBUS_CLIENT, GPasteDBusClient))
#define G_PASTE_IS_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_DBUS_CLIENT))
#define G_PASTE_DBUS_CLIENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_PASTE_TYPE_DBUS_CLIENT, GPasteDBusClientIface))

typedef struct _GPasteDBusClient GPasteDBusClient;
typedef struct _GPasteDBusClientIface GPasteDBusClientIface;

#define G_PASTE_TYPE_DBUS_CLIENT_PROXY (g_paste_dbus_client_proxy_get_type ())
typedef GDBusProxy GPasteDBusClientProxy;
typedef GDBusProxyClass GPasteDBusClientProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GPasteDBusClientIface {
	GTypeInterface parent_iface;
	gchar** (*get_history) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*backup_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*switch_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*delete_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	gchar** (*list_histories) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*add) (GPasteDBusClient* self, const gchar* selection, GError** error);
	gchar* (*get_element) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*select) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*delete) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*empty) (GPasteDBusClient* self, GError** error);
	void (*track) (GPasteDBusClient* self, gboolean tracking_state, GError** error);
	void (*reexec) (GPasteDBusClient* self, GError** error);
};



GType g_paste_dbus_client_proxy_get_type (void) G_GNUC_CONST;
guint g_paste_dbus_client_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType g_paste_dbus_client_get_type (void) G_GNUC_CONST;
gchar** g_paste_dbus_client_get_history (GPasteDBusClient* self, int* result_length1, GError** error);
void g_paste_dbus_client_backup_history (GPasteDBusClient* self, const gchar* name, GError** error);
void g_paste_dbus_client_switch_history (GPasteDBusClient* self, const gchar* name, GError** error);
void g_paste_dbus_client_delete_history (GPasteDBusClient* self, const gchar* name, GError** error);
gchar** g_paste_dbus_client_list_histories (GPasteDBusClient* self, int* result_length1, GError** error);
void g_paste_dbus_client_add (GPasteDBusClient* self, const gchar* selection, GError** error);
gchar* g_paste_dbus_client_get_element (GPasteDBusClient* self, guint32 pos, GError** error);
void g_paste_dbus_client_select (GPasteDBusClient* self, guint32 pos, GError** error);
void g_paste_dbus_client_delete (GPasteDBusClient* self, guint32 pos, GError** error);
void g_paste_dbus_client_empty (GPasteDBusClient* self, GError** error);
void g_paste_dbus_client_track (GPasteDBusClient* self, gboolean tracking_state, GError** error);
void g_paste_dbus_client_reexec (GPasteDBusClient* self, GError** error);
static void g_paste_dbus_client_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_g_paste_dbus_client_changed (GPasteDBusClient* self, GVariant* parameters);
static void _dbus_handle_g_paste_dbus_client_show_history (GPasteDBusClient* self, GVariant* parameters);
static gchar** g_paste_dbus_client_proxy_get_history (GPasteDBusClient* self, int* result_length1, GError** error);
static void g_paste_dbus_client_proxy_backup_history (GPasteDBusClient* self, const gchar* name, GError** error);
static void g_paste_dbus_client_proxy_switch_history (GPasteDBusClient* self, const gchar* name, GError** error);
static void g_paste_dbus_client_proxy_delete_history (GPasteDBusClient* self, const gchar* name, GError** error);
static gchar** g_paste_dbus_client_proxy_list_histories (GPasteDBusClient* self, int* result_length1, GError** error);
static void g_paste_dbus_client_proxy_add (GPasteDBusClient* self, const gchar* selection, GError** error);
static gchar* g_paste_dbus_client_proxy_get_element (GPasteDBusClient* self, guint32 pos, GError** error);
static void g_paste_dbus_client_proxy_select (GPasteDBusClient* self, guint32 pos, GError** error);
static void g_paste_dbus_client_proxy_delete (GPasteDBusClient* self, guint32 pos, GError** error);
static void g_paste_dbus_client_proxy_empty (GPasteDBusClient* self, GError** error);
static void g_paste_dbus_client_proxy_track (GPasteDBusClient* self, gboolean tracking_state, GError** error);
static void g_paste_dbus_client_proxy_reexec (GPasteDBusClient* self, GError** error);
static void g_paste_dbus_client_proxy_g_paste_dbus_client_interface_init (GPasteDBusClientIface* iface);
static void _dbus_g_paste_dbus_client_get_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_backup_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_switch_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_delete_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_list_histories (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_add (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_get_element (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_select (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_delete (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_empty (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_track (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_g_paste_dbus_client_reexec (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void g_paste_dbus_client_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* g_paste_dbus_client_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean g_paste_dbus_client_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_g_paste_dbus_client_changed (GObject* _sender, gpointer* _data);
static void _dbus_g_paste_dbus_client_show_history (GObject* _sender, gpointer* _data);
static void _g_paste_dbus_client_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_get_history_result = {-1, "result", "as"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_get_history_in[] = {NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_get_history_out[] = {&_g_paste_dbus_client_dbus_arg_info_get_history_result, NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_get_history = {-1, "GetHistory", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_get_history_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_get_history_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_backup_history_name = {-1, "name", "s"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_backup_history_in[] = {&_g_paste_dbus_client_dbus_arg_info_backup_history_name, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_backup_history_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_backup_history = {-1, "BackupHistory", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_backup_history_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_backup_history_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_switch_history_name = {-1, "name", "s"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_switch_history_in[] = {&_g_paste_dbus_client_dbus_arg_info_switch_history_name, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_switch_history_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_switch_history = {-1, "SwitchHistory", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_switch_history_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_switch_history_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_delete_history_name = {-1, "name", "s"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_delete_history_in[] = {&_g_paste_dbus_client_dbus_arg_info_delete_history_name, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_delete_history_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_delete_history = {-1, "DeleteHistory", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_delete_history_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_delete_history_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_list_histories_result = {-1, "result", "as"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_list_histories_in[] = {NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_list_histories_out[] = {&_g_paste_dbus_client_dbus_arg_info_list_histories_result, NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_list_histories = {-1, "ListHistories", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_list_histories_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_list_histories_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_add_selection = {-1, "selection", "s"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_add_in[] = {&_g_paste_dbus_client_dbus_arg_info_add_selection, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_add_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_add = {-1, "Add", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_add_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_add_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_get_element_pos = {-1, "pos", "u"};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_get_element_result = {-1, "result", "s"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_get_element_in[] = {&_g_paste_dbus_client_dbus_arg_info_get_element_pos, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_get_element_out[] = {&_g_paste_dbus_client_dbus_arg_info_get_element_result, NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_get_element = {-1, "GetElement", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_get_element_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_get_element_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_select_pos = {-1, "pos", "u"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_select_in[] = {&_g_paste_dbus_client_dbus_arg_info_select_pos, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_select_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_select = {-1, "Select", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_select_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_select_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_delete_pos = {-1, "pos", "u"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_delete_in[] = {&_g_paste_dbus_client_dbus_arg_info_delete_pos, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_delete_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_delete = {-1, "Delete", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_delete_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_delete_out)};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_empty_in[] = {NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_empty_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_empty = {-1, "Empty", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_empty_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_empty_out)};
static const GDBusArgInfo _g_paste_dbus_client_dbus_arg_info_track_tracking_state = {-1, "tracking_state", "b"};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_track_in[] = {&_g_paste_dbus_client_dbus_arg_info_track_tracking_state, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_track_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_track = {-1, "Track", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_track_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_track_out)};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_reexec_in[] = {NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_reexec_out[] = {NULL};
static const GDBusMethodInfo _g_paste_dbus_client_dbus_method_info_reexec = {-1, "Reexecute", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_reexec_in), (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_reexec_out)};
static const GDBusMethodInfo * const _g_paste_dbus_client_dbus_method_info[] = {&_g_paste_dbus_client_dbus_method_info_get_history, &_g_paste_dbus_client_dbus_method_info_backup_history, &_g_paste_dbus_client_dbus_method_info_switch_history, &_g_paste_dbus_client_dbus_method_info_delete_history, &_g_paste_dbus_client_dbus_method_info_list_histories, &_g_paste_dbus_client_dbus_method_info_add, &_g_paste_dbus_client_dbus_method_info_get_element, &_g_paste_dbus_client_dbus_method_info_select, &_g_paste_dbus_client_dbus_method_info_delete, &_g_paste_dbus_client_dbus_method_info_empty, &_g_paste_dbus_client_dbus_method_info_track, &_g_paste_dbus_client_dbus_method_info_reexec, NULL};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _g_paste_dbus_client_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_changed)};
static const GDBusArgInfo * const _g_paste_dbus_client_dbus_arg_info_show_history[] = {NULL};
static const GDBusSignalInfo _g_paste_dbus_client_dbus_signal_info_show_history = {-1, "ShowHistory", (GDBusArgInfo **) (&_g_paste_dbus_client_dbus_arg_info_show_history)};
static const GDBusSignalInfo * const _g_paste_dbus_client_dbus_signal_info[] = {&_g_paste_dbus_client_dbus_signal_info_changed, &_g_paste_dbus_client_dbus_signal_info_show_history, NULL};
static const GDBusPropertyInfo * const _g_paste_dbus_client_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _g_paste_dbus_client_dbus_interface_info = {-1, "org.gnome.GPaste", (GDBusMethodInfo **) (&_g_paste_dbus_client_dbus_method_info), (GDBusSignalInfo **) (&_g_paste_dbus_client_dbus_signal_info), (GDBusPropertyInfo **) (&_g_paste_dbus_client_dbus_property_info)};
static const GDBusInterfaceVTable _g_paste_dbus_client_dbus_interface_vtable = {g_paste_dbus_client_dbus_interface_method_call, g_paste_dbus_client_dbus_interface_get_property, g_paste_dbus_client_dbus_interface_set_property};

gchar** g_paste_dbus_client_get_history (GPasteDBusClient* self, int* result_length1, GError** error) {
	g_return_val_if_fail (G_PASTE_IS_DBUS_CLIENT (self), NULL);
	return G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->get_history (self, result_length1, error);
}


void g_paste_dbus_client_backup_history (GPasteDBusClient* self, const gchar* name, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->backup_history (self, name, error);
}


void g_paste_dbus_client_switch_history (GPasteDBusClient* self, const gchar* name, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->switch_history (self, name, error);
}


void g_paste_dbus_client_delete_history (GPasteDBusClient* self, const gchar* name, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->delete_history (self, name, error);
}


gchar** g_paste_dbus_client_list_histories (GPasteDBusClient* self, int* result_length1, GError** error) {
	g_return_val_if_fail (G_PASTE_IS_DBUS_CLIENT (self), NULL);
	return G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->list_histories (self, result_length1, error);
}


void g_paste_dbus_client_add (GPasteDBusClient* self, const gchar* selection, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->add (self, selection, error);
}


gchar* g_paste_dbus_client_get_element (GPasteDBusClient* self, guint32 pos, GError** error) {
	g_return_val_if_fail (G_PASTE_IS_DBUS_CLIENT (self), NULL);
	return G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->get_element (self, pos, error);
}


void g_paste_dbus_client_select (GPasteDBusClient* self, guint32 pos, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->select (self, pos, error);
}


void g_paste_dbus_client_delete (GPasteDBusClient* self, guint32 pos, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->delete (self, pos, error);
}


void g_paste_dbus_client_empty (GPasteDBusClient* self, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->empty (self, error);
}


void g_paste_dbus_client_track (GPasteDBusClient* self, gboolean tracking_state, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->track (self, tracking_state, error);
}


void g_paste_dbus_client_reexec (GPasteDBusClient* self, GError** error) {
	g_return_if_fail (G_PASTE_IS_DBUS_CLIENT (self));
	G_PASTE_DBUS_CLIENT_GET_INTERFACE (self)->reexec (self, error);
}


static void g_paste_dbus_client_base_init (GPasteDBusClientIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("changed", G_PASTE_TYPE_DBUS_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("show_history", G_PASTE_TYPE_DBUS_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	}
}


GType g_paste_dbus_client_get_type (void) {
	static volatile gsize g_paste_dbus_client_type_id__volatile = 0;
	if (g_once_init_enter (&g_paste_dbus_client_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDBusClientIface), (GBaseInitFunc) g_paste_dbus_client_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType g_paste_dbus_client_type_id;
		g_paste_dbus_client_type_id = g_type_register_static (G_TYPE_INTERFACE, "GPasteDBusClient", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (g_paste_dbus_client_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (g_paste_dbus_client_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) g_paste_dbus_client_proxy_get_type);
		g_type_set_qdata (g_paste_dbus_client_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.GPaste");
		g_type_set_qdata (g_paste_dbus_client_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) g_paste_dbus_client_register_object);
		g_once_init_leave (&g_paste_dbus_client_type_id__volatile, g_paste_dbus_client_type_id);
	}
	return g_paste_dbus_client_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (GPasteDBusClientProxy, g_paste_dbus_client_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (G_PASTE_TYPE_DBUS_CLIENT, g_paste_dbus_client_proxy_g_paste_dbus_client_interface_init) )
static void g_paste_dbus_client_proxy_class_init (GPasteDBusClientProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = g_paste_dbus_client_proxy_g_signal;
}


static void _dbus_handle_g_paste_dbus_client_changed (GPasteDBusClient* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "changed");
}


static void _dbus_handle_g_paste_dbus_client_show_history (GPasteDBusClient* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "show-history");
}


static void g_paste_dbus_client_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_g_paste_dbus_client_changed ((GPasteDBusClient*) proxy, parameters);
	} else if (strcmp (signal_name, "ShowHistory") == 0) {
		_dbus_handle_g_paste_dbus_client_show_history ((GPasteDBusClient*) proxy, parameters);
	}
}


static void g_paste_dbus_client_proxy_init (GPasteDBusClientProxy* self) {
}


static gchar** g_paste_dbus_client_proxy_get_history (GPasteDBusClient* self, int* result_length1, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar** _result;
	int _result_length1;
	GVariant* _tmp0_;
	gchar** _tmp1_;
	int _tmp1__length;
	int _tmp1__size;
	int _tmp1__length1;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "GetHistory");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp0_ = g_variant_iter_next_value (&_reply_iter);
	_tmp1_ = g_new (gchar*, 5);
	_tmp1__length = 0;
	_tmp1__size = 4;
	_tmp1__length1 = 0;
	g_variant_iter_init (&_tmp2_, _tmp0_);
	for (; (_tmp3_ = g_variant_iter_next_value (&_tmp2_)) != NULL; _tmp1__length1++) {
		if (_tmp1__size == _tmp1__length) {
			_tmp1__size = 2 * _tmp1__size;
			_tmp1_ = g_renew (gchar*, _tmp1_, _tmp1__size + 1);
		}
		_tmp1_[_tmp1__length++] = g_variant_dup_string (_tmp3_, NULL);
		g_variant_unref (_tmp3_);
	}
	_result_length1 = _tmp1__length1;
	_tmp1_[_tmp1__length] = NULL;
	_result = _tmp1_;
	g_variant_unref (_tmp0_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}


static void g_paste_dbus_client_proxy_backup_history (GPasteDBusClient* self, const gchar* name, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "BackupHistory");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_switch_history (GPasteDBusClient* self, const gchar* name, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "SwitchHistory");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_delete_history (GPasteDBusClient* self, const gchar* name, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "DeleteHistory");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar** g_paste_dbus_client_proxy_list_histories (GPasteDBusClient* self, int* result_length1, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar** _result;
	int _result_length1;
	GVariant* _tmp4_;
	gchar** _tmp5_;
	int _tmp5__length;
	int _tmp5__size;
	int _tmp5__length1;
	GVariantIter _tmp6_;
	GVariant* _tmp7_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "ListHistories");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp4_ = g_variant_iter_next_value (&_reply_iter);
	_tmp5_ = g_new (gchar*, 5);
	_tmp5__length = 0;
	_tmp5__size = 4;
	_tmp5__length1 = 0;
	g_variant_iter_init (&_tmp6_, _tmp4_);
	for (; (_tmp7_ = g_variant_iter_next_value (&_tmp6_)) != NULL; _tmp5__length1++) {
		if (_tmp5__size == _tmp5__length) {
			_tmp5__size = 2 * _tmp5__size;
			_tmp5_ = g_renew (gchar*, _tmp5_, _tmp5__size + 1);
		}
		_tmp5_[_tmp5__length++] = g_variant_dup_string (_tmp7_, NULL);
		g_variant_unref (_tmp7_);
	}
	_result_length1 = _tmp5__length1;
	_tmp5_[_tmp5__length] = NULL;
	_result = _tmp5_;
	g_variant_unref (_tmp4_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}


static void g_paste_dbus_client_proxy_add (GPasteDBusClient* self, const gchar* selection, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "Add");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (selection));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar* g_paste_dbus_client_proxy_get_element (GPasteDBusClient* self, guint32 pos, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp8_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "GetElement");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (pos));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp8_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	g_object_unref (_reply_message);
	return _result;
}


static void g_paste_dbus_client_proxy_select (GPasteDBusClient* self, guint32 pos, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "Select");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (pos));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_delete (GPasteDBusClient* self, guint32 pos, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "Delete");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (pos));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_empty (GPasteDBusClient* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "Empty");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_track (GPasteDBusClient* self, gboolean tracking_state, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "Track");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (tracking_state));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_reexec (GPasteDBusClient* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.GPaste", "Reexecute");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_proxy_g_paste_dbus_client_interface_init (GPasteDBusClientIface* iface) {
	iface->get_history = g_paste_dbus_client_proxy_get_history;
	iface->backup_history = g_paste_dbus_client_proxy_backup_history;
	iface->switch_history = g_paste_dbus_client_proxy_switch_history;
	iface->delete_history = g_paste_dbus_client_proxy_delete_history;
	iface->list_histories = g_paste_dbus_client_proxy_list_histories;
	iface->add = g_paste_dbus_client_proxy_add;
	iface->get_element = g_paste_dbus_client_proxy_get_element;
	iface->select = g_paste_dbus_client_proxy_select;
	iface->delete = g_paste_dbus_client_proxy_delete;
	iface->empty = g_paste_dbus_client_proxy_empty;
	iface->track = g_paste_dbus_client_proxy_track;
	iface->reexec = g_paste_dbus_client_proxy_reexec;
}


static void _dbus_g_paste_dbus_client_get_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp9_;
	GVariantBuilder _tmp10_;
	int _tmp11_;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = g_paste_dbus_client_get_history (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp9_ = result;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("as"));
	for (_tmp11_ = 0; _tmp11_ < result_length1; _tmp11_++) {
		g_variant_builder_add_value (&_tmp10_, g_variant_new_string (*_tmp9_));
		_tmp9_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp10_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_backup_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp12_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	g_paste_dbus_client_backup_history (self, name, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (name);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_switch_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	g_paste_dbus_client_switch_history (self, name, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (name);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_delete_history (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp14_, NULL);
	g_variant_unref (_tmp14_);
	g_paste_dbus_client_delete_history (self, name, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (name);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_list_histories (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp15_;
	GVariantBuilder _tmp16_;
	int _tmp17_;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = g_paste_dbus_client_list_histories (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp15_ = result;
	g_variant_builder_init (&_tmp16_, G_VARIANT_TYPE ("as"));
	for (_tmp17_ = 0; _tmp17_ < result_length1; _tmp17_++) {
		g_variant_builder_add_value (&_tmp16_, g_variant_new_string (*_tmp15_));
		_tmp15_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp16_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_add (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* selection = NULL;
	GVariant* _tmp18_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	selection = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	g_paste_dbus_client_add (self, selection, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (selection);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_get_element (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 pos = 0U;
	GVariant* _tmp19_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	pos = g_variant_get_uint32 (_tmp19_);
	g_variant_unref (_tmp19_);
	result = g_paste_dbus_client_get_element (self, pos, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_select (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 pos = 0U;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	pos = g_variant_get_uint32 (_tmp20_);
	g_variant_unref (_tmp20_);
	g_paste_dbus_client_select (self, pos, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_delete (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 pos = 0U;
	GVariant* _tmp21_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	pos = g_variant_get_uint32 (_tmp21_);
	g_variant_unref (_tmp21_);
	g_paste_dbus_client_delete (self, pos, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_empty (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_paste_dbus_client_empty (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_track (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean tracking_state = FALSE;
	GVariant* _tmp22_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp22_ = g_variant_iter_next_value (&_arguments_iter);
	tracking_state = g_variant_get_boolean (_tmp22_);
	g_variant_unref (_tmp22_);
	g_paste_dbus_client_track (self, tracking_state, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_g_paste_dbus_client_reexec (GPasteDBusClient* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_paste_dbus_client_reexec (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void g_paste_dbus_client_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetHistory") == 0) {
		_dbus_g_paste_dbus_client_get_history (object, parameters, invocation);
	} else if (strcmp (method_name, "BackupHistory") == 0) {
		_dbus_g_paste_dbus_client_backup_history (object, parameters, invocation);
	} else if (strcmp (method_name, "SwitchHistory") == 0) {
		_dbus_g_paste_dbus_client_switch_history (object, parameters, invocation);
	} else if (strcmp (method_name, "DeleteHistory") == 0) {
		_dbus_g_paste_dbus_client_delete_history (object, parameters, invocation);
	} else if (strcmp (method_name, "ListHistories") == 0) {
		_dbus_g_paste_dbus_client_list_histories (object, parameters, invocation);
	} else if (strcmp (method_name, "Add") == 0) {
		_dbus_g_paste_dbus_client_add (object, parameters, invocation);
	} else if (strcmp (method_name, "GetElement") == 0) {
		_dbus_g_paste_dbus_client_get_element (object, parameters, invocation);
	} else if (strcmp (method_name, "Select") == 0) {
		_dbus_g_paste_dbus_client_select (object, parameters, invocation);
	} else if (strcmp (method_name, "Delete") == 0) {
		_dbus_g_paste_dbus_client_delete (object, parameters, invocation);
	} else if (strcmp (method_name, "Empty") == 0) {
		_dbus_g_paste_dbus_client_empty (object, parameters, invocation);
	} else if (strcmp (method_name, "Track") == 0) {
		_dbus_g_paste_dbus_client_track (object, parameters, invocation);
	} else if (strcmp (method_name, "Reexecute") == 0) {
		_dbus_g_paste_dbus_client_reexec (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* g_paste_dbus_client_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean g_paste_dbus_client_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_g_paste_dbus_client_changed (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.GPaste", "Changed", _arguments, NULL);
}


static void _dbus_g_paste_dbus_client_show_history (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.GPaste", "ShowHistory", _arguments, NULL);
}


guint g_paste_dbus_client_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_g_paste_dbus_client_dbus_interface_info), &_g_paste_dbus_client_dbus_interface_vtable, data, _g_paste_dbus_client_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_g_paste_dbus_client_changed, data);
	g_signal_connect (object, "show-history", (GCallback) _dbus_g_paste_dbus_client_show_history, data);
	return result;
}


static void _g_paste_dbus_client_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_g_paste_dbus_client_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_g_paste_dbus_client_show_history, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



