/* gpaste-settings-window.c generated by valac 0.16.0, the Vala compiler
 * generated from gpaste-settings-window.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011-2012 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "gpaste.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdio.h>


#define G_PASTE_TYPE_WINDOW (g_paste_window_get_type ())
#define G_PASTE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_WINDOW, GPasteWindow))
#define G_PASTE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_WINDOW, GPasteWindowClass))
#define G_PASTE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_WINDOW))
#define G_PASTE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_WINDOW))
#define G_PASTE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_WINDOW, GPasteWindowClass))

typedef struct _GPasteWindow GPasteWindow;
typedef struct _GPasteWindowClass GPasteWindowClass;
typedef struct _GPasteWindowPrivate GPasteWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define G_PASTE_TYPE_PANEL (g_paste_panel_get_type ())
#define G_PASTE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_PANEL, GPastePanel))
#define G_PASTE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_PANEL, GPastePanelClass))
#define G_PASTE_IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_PANEL))
#define G_PASTE_IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_PANEL))
#define G_PASTE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_PANEL, GPastePanelClass))

typedef struct _GPastePanel GPastePanel;
typedef struct _GPastePanelClass GPastePanelClass;

#define G_PASTE_TYPE_MAIN (g_paste_main_get_type ())
#define G_PASTE_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_MAIN, GPasteMain))
#define G_PASTE_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_MAIN, GPasteMainClass))
#define G_PASTE_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_MAIN))
#define G_PASTE_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_MAIN))
#define G_PASTE_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_MAIN, GPasteMainClass))

typedef struct _GPasteMain GPasteMain;
typedef struct _GPasteMainClass GPasteMainClass;
typedef struct _GPasteMainPrivate GPasteMainPrivate;

#define G_PASTE_TYPE_DBUS_CLIENT (g_paste_dbus_client_get_type ())
#define G_PASTE_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_DBUS_CLIENT, GPasteDBusClient))
#define G_PASTE_IS_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_DBUS_CLIENT))
#define G_PASTE_DBUS_CLIENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_PASTE_TYPE_DBUS_CLIENT, GPasteDBusClientIface))

typedef struct _GPasteDBusClient GPasteDBusClient;
typedef struct _GPasteDBusClientIface GPasteDBusClientIface;

#define G_PASTE_TYPE_DBUS_CLIENT_PROXY (g_paste_dbus_client_proxy_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define G_PASTE_TYPE_NOTEBOOK (g_paste_notebook_get_type ())
#define G_PASTE_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_NOTEBOOK, GPasteNotebook))
#define G_PASTE_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_NOTEBOOK, GPasteNotebookClass))
#define G_PASTE_IS_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_NOTEBOOK))
#define G_PASTE_IS_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_NOTEBOOK))
#define G_PASTE_NOTEBOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_NOTEBOOK, GPasteNotebookClass))

typedef struct _GPasteNotebook GPasteNotebook;
typedef struct _GPasteNotebookClass GPasteNotebookClass;

struct _GPasteWindow {
	GtkWindow parent_instance;
	GPasteWindowPrivate * priv;
};

struct _GPasteWindowClass {
	GtkWindowClass parent_class;
};

struct _GPasteWindowPrivate {
	GPasteSettings* settings;
	GtkCheckButton* track_changes_button;
	GtkCheckButton* track_extension_state_button;
	GtkCheckButton* primary_to_history_button;
	GtkCheckButton* synchronize_clipboards_button;
	GtkCheckButton* save_history_button;
	GtkCheckButton* trim_items_button;
	GtkCheckButton* fifo_button;
	GtkSpinButton* max_history_size_button;
	GtkSpinButton* max_displayed_history_size_button;
	GtkSpinButton* element_size_button;
	GtkSpinButton* min_text_item_size_button;
	GtkSpinButton* max_text_item_size_button;
	GtkEntry* show_history_entry;
	GtkEntry* paste_and_pop_entry;
	GtkEntry* backup_entry;
	GtkComboBoxText* targets;
};

typedef void (*GPasteBooleanCallback) (gboolean data, void* user_data);
typedef void (*GPasteRangeCallback) (gdouble data, void* user_data);
typedef void (*GPasteTextCallback) (const gchar* data, void* user_data);
struct _GPasteDBusClientIface {
	GTypeInterface parent_iface;
	gchar** (*get_history) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*backup_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*switch_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*delete_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	gchar** (*list_histories) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*add) (GPasteDBusClient* self, const gchar* selection, GError** error);
	gchar* (*get_element) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*select) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*delete) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*empty) (GPasteDBusClient* self, GError** error);
	void (*track) (GPasteDBusClient* self, gboolean tracking_state, GError** error);
	void (*reexec) (GPasteDBusClient* self, GError** error);
};

struct _GPasteMain {
	GtkApplication parent_instance;
	GPasteMainPrivate * priv;
	GPasteDBusClient* gpaste;
};

struct _GPasteMainClass {
	GtkApplicationClass parent_class;
};

typedef void (*GPasteMultiActionCallback) (const gchar* action, const gchar* target, void* user_data);

static gpointer g_paste_window_parent_class = NULL;

GType g_paste_window_get_type (void) G_GNUC_CONST;
#define G_PASTE_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), G_PASTE_TYPE_WINDOW, GPasteWindowPrivate))
enum  {
	G_PASTE_WINDOW_DUMMY_PROPERTY
};
GPasteWindow* g_paste_window_new (GtkApplication* application);
GPasteWindow* g_paste_window_construct (GType object_type, GtkApplication* application);
static void __lambda2_ (GPasteWindow* self, const gchar* key);
static void ___lambda2__g_paste_settings_changed (GPasteSettings* _sender, const gchar* object, gpointer self);
static void g_paste_window_fill (GPasteWindow* self);
GType g_paste_panel_get_type (void) G_GNUC_CONST;
static GPastePanel* g_paste_window_make_behaviour_panel (GPasteWindow* self);
GPastePanel* g_paste_panel_new (void);
GPastePanel* g_paste_panel_construct (GType object_type);
GtkCheckButton* g_paste_panel_add_boolean_setting (GPastePanel* self, const gchar* label, gboolean value, GPasteBooleanCallback on_value_changed, void* on_value_changed_target);
static void __lambda8_ (GPasteWindow* self, gboolean value);
static void ___lambda8__gpaste_boolean_callback (gboolean data, gpointer self);
static void __lambda9_ (GPasteWindow* self, gboolean value);
static void ___lambda9__gpaste_boolean_callback (gboolean data, gpointer self);
void g_paste_panel_add_separator (GPastePanel* self);
static void __lambda10_ (GPasteWindow* self, gboolean value);
static void ___lambda10__gpaste_boolean_callback (gboolean data, gpointer self);
static void __lambda11_ (GPasteWindow* self, gboolean value);
static void ___lambda11__gpaste_boolean_callback (gboolean data, gpointer self);
static void __lambda12_ (GPasteWindow* self, gboolean value);
static void ___lambda12__gpaste_boolean_callback (gboolean data, gpointer self);
static void __lambda13_ (GPasteWindow* self, gboolean value);
static void ___lambda13__gpaste_boolean_callback (gboolean data, gpointer self);
static void __lambda14_ (GPasteWindow* self, gboolean value);
static void ___lambda14__gpaste_boolean_callback (gboolean data, gpointer self);
static GPastePanel* g_paste_window_make_history_settings_panel (GPasteWindow* self);
GtkSpinButton* g_paste_panel_add_range_setting (GPastePanel* self, const gchar* label, gdouble value, gdouble min, gdouble max, gdouble step, GPasteRangeCallback on_value_changed, void* on_value_changed_target);
static void __lambda15_ (GPasteWindow* self, gdouble value);
static void ___lambda15__gpaste_range_callback (gdouble data, gpointer self);
static void __lambda16_ (GPasteWindow* self, gdouble value);
static void ___lambda16__gpaste_range_callback (gdouble data, gpointer self);
static void __lambda17_ (GPasteWindow* self, gdouble value);
static void ___lambda17__gpaste_range_callback (gdouble data, gpointer self);
static void __lambda18_ (GPasteWindow* self, gdouble value);
static void ___lambda18__gpaste_range_callback (gdouble data, gpointer self);
static void __lambda19_ (GPasteWindow* self, gdouble value);
static void ___lambda19__gpaste_range_callback (gdouble data, gpointer self);
static GPastePanel* g_paste_window_make_keybindings_panel (GPasteWindow* self);
GtkEntry* g_paste_panel_add_text_setting (GPastePanel* self, const gchar* label, const gchar* value, GPasteTextCallback on_value_changed, void* on_value_changed_target);
static void __lambda20_ (GPasteWindow* self, const gchar* value);
static void ___lambda20__gpaste_text_callback (const gchar* data, gpointer self);
static void __lambda21_ (GPasteWindow* self, const gchar* value);
static void ___lambda21__gpaste_text_callback (const gchar* data, gpointer self);
static void g_paste_window_refill_histories (GPasteWindow* self);
static GPastePanel* g_paste_window_make_histories_panel (GPasteWindow* self);
GtkEntry* g_paste_panel_add_text_confirm_setting (GPastePanel* self, const gchar* label, const gchar* value, GPasteTextCallback on_value_changed, void* on_value_changed_target, const gchar* confirm_label, GPasteTextCallback confirm_action, void* confirm_action_target);
static void __lambda22_ (GPasteWindow* self, const gchar* value);
static void ___lambda22__gpaste_text_callback (const gchar* data, gpointer self);
static void __lambda23_ (GPasteWindow* self, const gchar* value);
GType g_paste_main_get_type (void) G_GNUC_CONST;
GType g_paste_dbus_client_proxy_get_type (void) G_GNUC_CONST;
guint g_paste_dbus_client_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType g_paste_dbus_client_get_type (void) G_GNUC_CONST;
void g_paste_dbus_client_backup_history (GPasteDBusClient* self, const gchar* name, GError** error);
static void ___lambda23__gpaste_text_callback (const gchar* data, gpointer self);
GtkComboBoxText* g_paste_panel_add_multi_action_setting (GPastePanel* self, gchar** action_labels, int action_labels_length1, int action_labels_length2, gchar** target_labels, int target_labels_length1, const gchar* confirm_label, GPasteMultiActionCallback confirm_action, void* confirm_action_target);
static void __lambda24_ (GPasteWindow* self, const gchar* action, const gchar* target);
void g_paste_dbus_client_switch_history (GPasteDBusClient* self, const gchar* name, GError** error);
void g_paste_dbus_client_delete_history (GPasteDBusClient* self, const gchar* name, GError** error);
static void ___lambda24__gpaste_multi_action_callback (const gchar* action, const gchar* target, gpointer self);
GPasteNotebook* g_paste_notebook_new (void);
GPasteNotebook* g_paste_notebook_construct (GType object_type);
GType g_paste_notebook_get_type (void) G_GNUC_CONST;
void g_paste_notebook_add_panel (GPasteNotebook* self, const gchar* label, GPastePanel* panel);
static void g_paste_window_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void __lambda2_ (GPasteWindow* self, const gchar* key) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	static GQuark _tmp2_label7 = 0;
	static GQuark _tmp2_label8 = 0;
	static GQuark _tmp2_label9 = 0;
	static GQuark _tmp2_label10 = 0;
	static GQuark _tmp2_label11 = 0;
	static GQuark _tmp2_label12 = 0;
	static GQuark _tmp2_label13 = 0;
	static GQuark _tmp2_label14 = 0;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("track-changes")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp4_;
				GPasteSettings* _tmp5_;
				gboolean _tmp6_ = FALSE;
				_tmp4_ = self->priv->track_changes_button;
				_tmp5_ = self->priv->settings;
				_tmp6_ = g_paste_settings_get_track_changes (_tmp5_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp4_), _tmp6_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("track-extension-state")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp7_;
				GPasteSettings* _tmp8_;
				gboolean _tmp9_ = FALSE;
				_tmp7_ = self->priv->track_extension_state_button;
				_tmp8_ = self->priv->settings;
				_tmp9_ = g_paste_settings_get_track_extension_state (_tmp8_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp7_), _tmp9_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("primary-to-history")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp10_;
				GPasteSettings* _tmp11_;
				gboolean _tmp12_ = FALSE;
				_tmp10_ = self->priv->primary_to_history_button;
				_tmp11_ = self->priv->settings;
				_tmp12_ = g_paste_settings_get_primary_to_history (_tmp11_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp10_), _tmp12_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("synchronize_clipboards")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp13_;
				GPasteSettings* _tmp14_;
				gboolean _tmp15_ = FALSE;
				_tmp13_ = self->priv->synchronize_clipboards_button;
				_tmp14_ = self->priv->settings;
				_tmp15_ = g_paste_settings_get_synchronize_clipboards (_tmp14_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp13_), _tmp15_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("save-history")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp16_;
				GPasteSettings* _tmp17_;
				gboolean _tmp18_ = FALSE;
				_tmp16_ = self->priv->save_history_button;
				_tmp17_ = self->priv->settings;
				_tmp18_ = g_paste_settings_get_save_history (_tmp17_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp16_), _tmp18_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("trim-items")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp19_;
				GPasteSettings* _tmp20_;
				gboolean _tmp21_ = FALSE;
				_tmp19_ = self->priv->trim_items_button;
				_tmp20_ = self->priv->settings;
				_tmp21_ = g_paste_settings_get_trim_items (_tmp20_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp19_), _tmp21_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("fifo")))) {
		switch (0) {
			default:
			{
				GtkCheckButton* _tmp22_;
				GPasteSettings* _tmp23_;
				gboolean _tmp24_ = FALSE;
				_tmp22_ = self->priv->fifo_button;
				_tmp23_ = self->priv->settings;
				_tmp24_ = g_paste_settings_get_fifo (_tmp23_);
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (_tmp22_), _tmp24_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("max-history-size")))) {
		switch (0) {
			default:
			{
				GtkSpinButton* _tmp25_;
				GPasteSettings* _tmp26_;
				guint _tmp27_ = 0U;
				_tmp25_ = self->priv->max_history_size_button;
				_tmp26_ = self->priv->settings;
				_tmp27_ = g_paste_settings_get_max_history_size (_tmp26_);
				gtk_spin_button_set_value (_tmp25_, (gdouble) _tmp27_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("max-displayed-history-size")))) {
		switch (0) {
			default:
			{
				GtkSpinButton* _tmp28_;
				GPasteSettings* _tmp29_;
				guint _tmp30_ = 0U;
				_tmp28_ = self->priv->max_displayed_history_size_button;
				_tmp29_ = self->priv->settings;
				_tmp30_ = g_paste_settings_get_max_displayed_history_size (_tmp29_);
				gtk_spin_button_set_value (_tmp28_, (gdouble) _tmp30_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("element-size")))) {
		switch (0) {
			default:
			{
				GtkSpinButton* _tmp31_;
				GPasteSettings* _tmp32_;
				guint _tmp33_ = 0U;
				_tmp31_ = self->priv->element_size_button;
				_tmp32_ = self->priv->settings;
				_tmp33_ = g_paste_settings_get_element_size (_tmp32_);
				gtk_spin_button_set_value (_tmp31_, (gdouble) _tmp33_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("min-text-item-size")))) {
		switch (0) {
			default:
			{
				GtkSpinButton* _tmp34_;
				GPasteSettings* _tmp35_;
				guint _tmp36_ = 0U;
				_tmp34_ = self->priv->min_text_item_size_button;
				_tmp35_ = self->priv->settings;
				_tmp36_ = g_paste_settings_get_min_text_item_size (_tmp35_);
				gtk_spin_button_set_value (_tmp34_, (gdouble) _tmp36_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("max-text-item-size")))) {
		switch (0) {
			default:
			{
				GtkSpinButton* _tmp37_;
				GPasteSettings* _tmp38_;
				guint _tmp39_ = 0U;
				_tmp37_ = self->priv->max_text_item_size_button;
				_tmp38_ = self->priv->settings;
				_tmp39_ = g_paste_settings_get_max_text_item_size (_tmp38_);
				gtk_spin_button_set_value (_tmp37_, (gdouble) _tmp39_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("show-history")))) {
		switch (0) {
			default:
			{
				GtkEntry* _tmp40_;
				GPasteSettings* _tmp41_;
				const gchar* _tmp42_ = NULL;
				_tmp40_ = self->priv->show_history_entry;
				_tmp41_ = self->priv->settings;
				_tmp42_ = g_paste_settings_get_show_history (_tmp41_);
				gtk_entry_set_text (_tmp40_, _tmp42_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("paste-and-pop")))) {
		switch (0) {
			default:
			{
				GtkEntry* _tmp43_;
				GPasteSettings* _tmp44_;
				const gchar* _tmp45_ = NULL;
				_tmp43_ = self->priv->paste_and_pop_entry;
				_tmp44_ = self->priv->settings;
				_tmp45_ = g_paste_settings_get_paste_and_pop (_tmp44_);
				gtk_entry_set_text (_tmp43_, _tmp45_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("history-name")))) {
		switch (0) {
			default:
			{
				GtkEntry* _tmp46_;
				GPasteSettings* _tmp47_;
				const gchar* _tmp48_ = NULL;
				gchar* _tmp49_;
				gchar* _tmp50_;
				_tmp46_ = self->priv->backup_entry;
				_tmp47_ = self->priv->settings;
				_tmp48_ = g_paste_settings_get_history_name (_tmp47_);
				_tmp49_ = g_strconcat (_tmp48_, "_backup", NULL);
				_tmp50_ = _tmp49_;
				gtk_entry_set_text (_tmp46_, _tmp50_);
				_g_free0 (_tmp50_);
				break;
			}
		}
	}
}


static void ___lambda2__g_paste_settings_changed (GPasteSettings* _sender, const gchar* object, gpointer self) {
	__lambda2_ (self, object);
}


GPasteWindow* g_paste_window_construct (GType object_type, GtkApplication* application) {
	GPasteWindow * self = NULL;
	GPasteSettings* _tmp0_;
	GPasteSettings* _tmp1_;
	GtkApplication* _tmp2_;
	const gchar* _tmp3_ = NULL;
	g_return_val_if_fail (GTK_IS_APPLICATION (application), NULL);
	self = (GPasteWindow*) g_object_new (object_type, "type", GTK_WINDOW_TOPLEVEL, NULL);
	_tmp0_ = g_paste_settings_new ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = self->priv->settings;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) ___lambda2__g_paste_settings_changed, self, 0);
	_tmp2_ = application;
	gtk_window_set_application (GTK_WINDOW (self), _tmp2_);
	_tmp3_ = _ ("GPaste daemon settings");
	gtk_window_set_title (GTK_WINDOW (self), _tmp3_);
	gtk_window_set_position (GTK_WINDOW (self), GTK_WIN_POS_CENTER);
	gtk_window_set_resizable (GTK_WINDOW (self), FALSE);
	g_paste_window_fill (self);
	return self;
}


GPasteWindow* g_paste_window_new (GtkApplication* application) {
	return g_paste_window_construct (G_PASTE_TYPE_WINDOW, application);
}


static void __lambda8_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_track_changes (_tmp0_, _tmp1_);
}


static void ___lambda8__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda8_ (self, data);
}


static void __lambda9_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_track_extension_state (_tmp0_, _tmp1_);
}


static void ___lambda9__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda9_ (self, data);
}


static void __lambda10_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_primary_to_history (_tmp0_, _tmp1_);
}


static void ___lambda10__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda10_ (self, data);
}


static void __lambda11_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_synchronize_clipboards (_tmp0_, _tmp1_);
}


static void ___lambda11__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda11_ (self, data);
}


static void __lambda12_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_save_history (_tmp0_, _tmp1_);
}


static void ___lambda12__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda12_ (self, data);
}


static void __lambda13_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_trim_items (_tmp0_, _tmp1_);
}


static void ___lambda13__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda13_ (self, data);
}


static void __lambda14_ (GPasteWindow* self, gboolean value) {
	GPasteSettings* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_fifo (_tmp0_, _tmp1_);
}


static void ___lambda14__gpaste_boolean_callback (gboolean data, gpointer self) {
	__lambda14_ (self, data);
}


static GPastePanel* g_paste_window_make_behaviour_panel (GPasteWindow* self) {
	GPastePanel* result = NULL;
	GPastePanel* _tmp0_;
	GPastePanel* _tmp1_;
	GPastePanel* panel;
	const gchar* _tmp2_ = NULL;
	GPasteSettings* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkCheckButton* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GPasteSettings* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkCheckButton* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	GPasteSettings* _tmp11_;
	gboolean _tmp12_ = FALSE;
	GtkCheckButton* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	GPasteSettings* _tmp15_;
	gboolean _tmp16_ = FALSE;
	GtkCheckButton* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	GPasteSettings* _tmp19_;
	gboolean _tmp20_ = FALSE;
	GtkCheckButton* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	GPasteSettings* _tmp23_;
	gboolean _tmp24_ = FALSE;
	GtkCheckButton* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	GPasteSettings* _tmp27_;
	gboolean _tmp28_ = FALSE;
	GtkCheckButton* _tmp29_ = NULL;
	g_return_val_if_fail (G_PASTE_IS_WINDOW (self), NULL);
	_tmp0_ = g_paste_panel_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	panel = _tmp1_;
	_tmp2_ = _ ("_Track clipboard changes");
	_tmp3_ = self->priv->settings;
	_tmp4_ = g_paste_settings_get_track_changes (_tmp3_);
	_tmp5_ = g_paste_panel_add_boolean_setting (panel, _tmp2_, _tmp4_, ___lambda8__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->track_changes_button);
	self->priv->track_changes_button = _tmp5_;
	_tmp6_ = _ ("Sync the daemon state with the _extension's one");
	_tmp7_ = self->priv->settings;
	_tmp8_ = g_paste_settings_get_track_extension_state (_tmp7_);
	_tmp9_ = g_paste_panel_add_boolean_setting (panel, _tmp6_, _tmp8_, ___lambda9__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->track_extension_state_button);
	self->priv->track_extension_state_button = _tmp9_;
	g_paste_panel_add_separator (panel);
	_tmp10_ = _ ("_Primary selection affects history");
	_tmp11_ = self->priv->settings;
	_tmp12_ = g_paste_settings_get_primary_to_history (_tmp11_);
	_tmp13_ = g_paste_panel_add_boolean_setting (panel, _tmp10_, _tmp12_, ___lambda10__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->primary_to_history_button);
	self->priv->primary_to_history_button = _tmp13_;
	_tmp14_ = _ ("_Synchronize clipboard with primary selection");
	_tmp15_ = self->priv->settings;
	_tmp16_ = g_paste_settings_get_synchronize_clipboards (_tmp15_);
	_tmp17_ = g_paste_panel_add_boolean_setting (panel, _tmp14_, _tmp16_, ___lambda11__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	self->priv->synchronize_clipboards_button = _tmp17_;
	g_paste_panel_add_separator (panel);
	_tmp18_ = _ ("_Save history");
	_tmp19_ = self->priv->settings;
	_tmp20_ = g_paste_settings_get_save_history (_tmp19_);
	_tmp21_ = g_paste_panel_add_boolean_setting (panel, _tmp18_, _tmp20_, ___lambda12__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->save_history_button);
	self->priv->save_history_button = _tmp21_;
	_tmp22_ = _ ("_Trim items");
	_tmp23_ = self->priv->settings;
	_tmp24_ = g_paste_settings_get_trim_items (_tmp23_);
	_tmp25_ = g_paste_panel_add_boolean_setting (panel, _tmp22_, _tmp24_, ___lambda13__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->trim_items_button);
	self->priv->trim_items_button = _tmp25_;
	_tmp26_ = _ ("_Copy to end of history");
	_tmp27_ = self->priv->settings;
	_tmp28_ = g_paste_settings_get_fifo (_tmp27_);
	_tmp29_ = g_paste_panel_add_boolean_setting (panel, _tmp26_, _tmp28_, ___lambda14__gpaste_boolean_callback, self);
	_g_object_unref0 (self->priv->fifo_button);
	self->priv->fifo_button = _tmp29_;
	result = panel;
	return result;
}


static void __lambda15_ (GPasteWindow* self, gdouble value) {
	GPasteSettings* _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_max_history_size (_tmp0_, (guint) _tmp1_);
}


static void ___lambda15__gpaste_range_callback (gdouble data, gpointer self) {
	__lambda15_ (self, data);
}


static void __lambda16_ (GPasteWindow* self, gdouble value) {
	GPasteSettings* _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_max_displayed_history_size (_tmp0_, (guint) _tmp1_);
}


static void ___lambda16__gpaste_range_callback (gdouble data, gpointer self) {
	__lambda16_ (self, data);
}


static void __lambda17_ (GPasteWindow* self, gdouble value) {
	GPasteSettings* _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_element_size (_tmp0_, (guint) _tmp1_);
}


static void ___lambda17__gpaste_range_callback (gdouble data, gpointer self) {
	__lambda17_ (self, data);
}


static void __lambda18_ (GPasteWindow* self, gdouble value) {
	GPasteSettings* _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_min_text_item_size (_tmp0_, (guint) _tmp1_);
}


static void ___lambda18__gpaste_range_callback (gdouble data, gpointer self) {
	__lambda18_ (self, data);
}


static void __lambda19_ (GPasteWindow* self, gdouble value) {
	GPasteSettings* _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_max_text_item_size (_tmp0_, (guint) _tmp1_);
}


static void ___lambda19__gpaste_range_callback (gdouble data, gpointer self) {
	__lambda19_ (self, data);
}


static GPastePanel* g_paste_window_make_history_settings_panel (GPasteWindow* self) {
	GPastePanel* result = NULL;
	GPastePanel* _tmp0_;
	GPastePanel* _tmp1_;
	GPastePanel* panel;
	const gchar* _tmp2_ = NULL;
	GPasteSettings* _tmp3_;
	guint _tmp4_ = 0U;
	GtkSpinButton* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GPasteSettings* _tmp7_;
	guint _tmp8_ = 0U;
	GtkSpinButton* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	GPasteSettings* _tmp11_;
	guint _tmp12_ = 0U;
	GtkSpinButton* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	GPasteSettings* _tmp15_;
	guint _tmp16_ = 0U;
	guint32 _tmp17_;
	GtkSpinButton* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	GPasteSettings* _tmp20_;
	guint _tmp21_ = 0U;
	guint32 _tmp22_;
	GtkSpinButton* _tmp23_ = NULL;
	g_return_val_if_fail (G_PASTE_IS_WINDOW (self), NULL);
	_tmp0_ = g_paste_panel_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	panel = _tmp1_;
	_tmp2_ = _ ("Max history size: ");
	_tmp3_ = self->priv->settings;
	_tmp4_ = g_paste_settings_get_max_history_size (_tmp3_);
	_tmp5_ = g_paste_panel_add_range_setting (panel, _tmp2_, (gdouble) _tmp4_, (gdouble) 5, (gdouble) 255, (gdouble) 5, ___lambda15__gpaste_range_callback, self);
	_g_object_unref0 (self->priv->max_history_size_button);
	self->priv->max_history_size_button = _tmp5_;
	_tmp6_ = _ ("Max displayed history size: ");
	_tmp7_ = self->priv->settings;
	_tmp8_ = g_paste_settings_get_max_displayed_history_size (_tmp7_);
	_tmp9_ = g_paste_panel_add_range_setting (panel, _tmp6_, (gdouble) _tmp8_, (gdouble) 5, (gdouble) 255, (gdouble) 5, ___lambda16__gpaste_range_callback, self);
	_g_object_unref0 (self->priv->max_displayed_history_size_button);
	self->priv->max_displayed_history_size_button = _tmp9_;
	_tmp10_ = _ ("Max element size when displaying: ");
	_tmp11_ = self->priv->settings;
	_tmp12_ = g_paste_settings_get_element_size (_tmp11_);
	_tmp13_ = g_paste_panel_add_range_setting (panel, _tmp10_, (gdouble) _tmp12_, (gdouble) 0, (gdouble) 255, (gdouble) 5, ___lambda17__gpaste_range_callback, self);
	_g_object_unref0 (self->priv->element_size_button);
	self->priv->element_size_button = _tmp13_;
	_tmp14_ = _ ("Min text item length: ");
	_tmp15_ = self->priv->settings;
	_tmp16_ = g_paste_settings_get_min_text_item_size (_tmp15_);
	_tmp17_ = G_MAXUINT32;
	_tmp18_ = g_paste_panel_add_range_setting (panel, _tmp14_, (gdouble) _tmp16_, (gdouble) 1, (gdouble) _tmp17_, (gdouble) 1, ___lambda18__gpaste_range_callback, self);
	_g_object_unref0 (self->priv->min_text_item_size_button);
	self->priv->min_text_item_size_button = _tmp18_;
	_tmp19_ = _ ("Max text item length: ");
	_tmp20_ = self->priv->settings;
	_tmp21_ = g_paste_settings_get_max_text_item_size (_tmp20_);
	_tmp22_ = G_MAXUINT32;
	_tmp23_ = g_paste_panel_add_range_setting (panel, _tmp19_, (gdouble) _tmp21_, (gdouble) 1, (gdouble) _tmp22_, (gdouble) 1, ___lambda19__gpaste_range_callback, self);
	_g_object_unref0 (self->priv->max_text_item_size_button);
	self->priv->max_text_item_size_button = _tmp23_;
	result = panel;
	return result;
}


static void __lambda20_ (GPasteWindow* self, const gchar* value) {
	GPasteSettings* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_show_history (_tmp0_, _tmp1_);
}


static void ___lambda20__gpaste_text_callback (const gchar* data, gpointer self) {
	__lambda20_ (self, data);
}


static void __lambda21_ (GPasteWindow* self, const gchar* value) {
	GPasteSettings* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_paste_settings_set_paste_and_pop (_tmp0_, _tmp1_);
}


static void ___lambda21__gpaste_text_callback (const gchar* data, gpointer self) {
	__lambda21_ (self, data);
}


static GPastePanel* g_paste_window_make_keybindings_panel (GPasteWindow* self) {
	GPastePanel* result = NULL;
	GPastePanel* _tmp0_;
	GPastePanel* _tmp1_;
	GPastePanel* panel;
	const gchar* _tmp2_ = NULL;
	GPasteSettings* _tmp3_;
	const gchar* _tmp4_ = NULL;
	GtkEntry* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GPasteSettings* _tmp7_;
	const gchar* _tmp8_ = NULL;
	GtkEntry* _tmp9_ = NULL;
	g_return_val_if_fail (G_PASTE_IS_WINDOW (self), NULL);
	_tmp0_ = g_paste_panel_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	panel = _tmp1_;
	_tmp2_ = _ ("Display the history: ");
	_tmp3_ = self->priv->settings;
	_tmp4_ = g_paste_settings_get_show_history (_tmp3_);
	_tmp5_ = g_paste_panel_add_text_setting (panel, _tmp2_, _tmp4_, ___lambda20__gpaste_text_callback, self);
	_g_object_unref0 (self->priv->show_history_entry);
	self->priv->show_history_entry = _tmp5_;
	_tmp6_ = _ ("Paste and then delete the first item in history: ");
	_tmp7_ = self->priv->settings;
	_tmp8_ = g_paste_settings_get_paste_and_pop (_tmp7_);
	_tmp9_ = g_paste_panel_add_text_setting (panel, _tmp6_, _tmp8_, ___lambda21__gpaste_text_callback, self);
	_g_object_unref0 (self->priv->paste_and_pop_entry);
	self->priv->paste_and_pop_entry = _tmp9_;
	result = panel;
	return result;
}


static void g_paste_window_refill_histories (GPasteWindow* self) {
	GtkComboBoxText* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	GtkComboBoxText* _tmp7_;
	GPasteSettings* _tmp8_;
	const gchar* _tmp9_ = NULL;
	g_return_if_fail (G_PASTE_IS_WINDOW (self));
	_tmp0_ = self->priv->targets;
	gtk_combo_box_text_remove_all (_tmp0_);
	_tmp2_ = _tmp1_ = g_paste_history_list ();
	{
		gchar** label_collection = NULL;
		gint label_collection_length1 = 0;
		gint _label_collection_size_ = 0;
		gint label_it = 0;
		label_collection = _tmp2_;
		label_collection_length1 = _vala_array_length (_tmp1_);
		for (label_it = 0; label_it < _vala_array_length (_tmp1_); label_it = label_it + 1) {
			gchar* _tmp3_;
			gchar* label = NULL;
			_tmp3_ = g_strdup (label_collection[label_it]);
			label = _tmp3_;
			{
				GtkComboBoxText* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				_tmp4_ = self->priv->targets;
				_tmp5_ = label;
				_tmp6_ = label;
				gtk_combo_box_text_append (_tmp4_, _tmp5_, _tmp6_);
				_g_free0 (label);
			}
		}
		label_collection = (_vala_array_free (label_collection, label_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp7_ = self->priv->targets;
	_tmp8_ = self->priv->settings;
	_tmp9_ = g_paste_settings_get_history_name (_tmp8_);
	gtk_combo_box_set_active_id (GTK_COMBO_BOX (_tmp7_), _tmp9_);
}


static void __lambda22_ (GPasteWindow* self, const gchar* value) {
	g_return_if_fail (value != NULL);
}


static void ___lambda22__gpaste_text_callback (const gchar* data, gpointer self) {
	__lambda22_ (self, data);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda23_ (GPasteWindow* self, const gchar* value) {
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GPasteMain* _tmp2_;
	GPasteMain* app;
	GError * _inner_error_ = NULL;
	g_return_if_fail (value != NULL);
	_tmp0_ = gtk_window_get_application (GTK_WINDOW (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (G_PASTE_MAIN (_tmp1_));
	app = _tmp2_;
	{
		GPasteDBusClient* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = app->gpaste;
		_tmp4_ = value;
		g_paste_dbus_client_backup_history (_tmp3_, _tmp4_, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch1_g_io_error;
			}
			_g_object_unref0 (app);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		g_paste_window_refill_histories (self);
	}
	goto __finally1;
	__catch1_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = _ ("Couldn't connect to GPaste daemon.\n");
		fprintf (_tmp5_, "%s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (app);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (app);
}


static void ___lambda23__gpaste_text_callback (const gchar* data, gpointer self) {
	__lambda23_ (self, data);
}


static void __lambda24_ (GPasteWindow* self, const gchar* action, const gchar* target) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (action != NULL);
	g_return_if_fail (target != NULL);
	{
		GtkApplication* _tmp0_;
		GtkApplication* _tmp1_;
		GPasteMain* _tmp2_;
		GPasteMain* app;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GQuark _tmp6_ = 0U;
		static GQuark _tmp5_label0 = 0;
		static GQuark _tmp5_label1 = 0;
		_tmp0_ = gtk_window_get_application (GTK_WINDOW (self));
		_tmp1_ = _tmp0_;
		_tmp2_ = _g_object_ref0 (G_PASTE_MAIN (_tmp1_));
		app = _tmp2_;
		_tmp3_ = action;
		_tmp4_ = _tmp3_;
		_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
		if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("switch")))) {
			switch (0) {
				default:
				{
					GPasteMain* _tmp7_;
					GPasteDBusClient* _tmp8_;
					const gchar* _tmp9_;
					_tmp7_ = app;
					_tmp8_ = _tmp7_->gpaste;
					_tmp9_ = target;
					g_paste_dbus_client_switch_history (_tmp8_, _tmp9_, &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_object_unref0 (app);
						if (_inner_error_->domain == G_IO_ERROR) {
							goto __catch2_g_io_error;
						}
						_g_object_unref0 (app);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					break;
				}
			}
		} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("delete")))) {
			switch (0) {
				default:
				{
					GPasteMain* _tmp10_;
					GPasteDBusClient* _tmp11_;
					const gchar* _tmp12_;
					_tmp10_ = app;
					_tmp11_ = _tmp10_->gpaste;
					_tmp12_ = target;
					g_paste_dbus_client_delete_history (_tmp11_, _tmp12_, &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_object_unref0 (app);
						if (_inner_error_->domain == G_IO_ERROR) {
							goto __catch2_g_io_error;
						}
						_g_object_unref0 (app);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					FILE* _tmp13_;
					const gchar* _tmp14_;
					_tmp13_ = stdout;
					_tmp14_ = action;
					fprintf (_tmp13_, "%s\n", _tmp14_);
					break;
				}
			}
		}
		g_paste_window_refill_histories (self);
		_g_object_unref0 (app);
	}
	goto __finally2;
	__catch2_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp15_;
		const gchar* _tmp16_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp15_ = stderr;
		_tmp16_ = _ ("Couldn't connect to GPaste daemon.\n");
		fprintf (_tmp15_, "%s", _tmp16_);
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda24__gpaste_multi_action_callback (const gchar* action, const gchar* target, gpointer self) {
	__lambda24_ (self, action, target);
}


static GPastePanel* g_paste_window_make_histories_panel (GPasteWindow* self) {
	GPastePanel* result = NULL;
	GPastePanel* _tmp0_;
	GPastePanel* _tmp1_;
	GPastePanel* panel;
	const gchar* _tmp2_ = NULL;
	GPasteSettings* _tmp3_;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	GtkEntry* _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	gchar** _tmp15_ = NULL;
	gchar** actions;
	gint actions_length1;
	gint actions_length2;
	gchar** _tmp16_;
	gchar** _tmp17_ = NULL;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_ = NULL;
	GtkComboBoxText* _tmp20_ = NULL;
	g_return_val_if_fail (G_PASTE_IS_WINDOW (self), NULL);
	_tmp0_ = g_paste_panel_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	panel = _tmp1_;
	_tmp2_ = _ ("Backup history as: ");
	_tmp3_ = self->priv->settings;
	_tmp4_ = g_paste_settings_get_history_name (_tmp3_);
	_tmp5_ = g_strconcat (_tmp4_, "_backup", NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = _ ("Backup");
	_tmp8_ = g_paste_panel_add_text_confirm_setting (panel, _tmp2_, _tmp6_, ___lambda22__gpaste_text_callback, self, _tmp7_, ___lambda23__gpaste_text_callback, self);
	_g_object_unref0 (self->priv->backup_entry);
	self->priv->backup_entry = _tmp8_;
	_g_free0 (_tmp6_);
	_tmp9_ = g_strdup ("switch");
	_tmp10_ = _ ("Switch to");
	_tmp11_ = g_strdup (_tmp10_);
	_tmp12_ = g_strdup ("delete");
	_tmp13_ = _ ("Delete");
	_tmp14_ = g_strdup (_tmp13_);
	_tmp15_ = g_new0 (gchar*, (2 * 2) + 1);
	_tmp15_[0] = _tmp9_;
	_tmp15_[1] = _tmp11_;
	_tmp15_[2] = _tmp12_;
	_tmp15_[3] = _tmp14_;
	actions = _tmp15_;
	actions_length1 = 2;
	actions_length2 = 2;
	_tmp17_ = _tmp16_ = g_paste_history_list ();
	_tmp18_ = _tmp17_;
	_tmp18__length1 = _vala_array_length (_tmp16_);
	_tmp19_ = _ ("Ok");
	_tmp20_ = g_paste_panel_add_multi_action_setting (panel, actions, actions_length1, actions_length2, _tmp18_, _vala_array_length (_tmp16_), _tmp19_, ___lambda24__gpaste_multi_action_callback, self);
	_g_object_unref0 (self->priv->targets);
	self->priv->targets = _tmp20_;
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
	g_paste_window_refill_histories (self);
	result = panel;
	actions = (_vala_array_free (actions, actions_length1 * actions_length2, (GDestroyNotify) g_free), NULL);
	return result;
}


static void g_paste_window_fill (GPasteWindow* self) {
	GPasteNotebook* _tmp0_;
	GPasteNotebook* _tmp1_;
	GPasteNotebook* notebook;
	const gchar* _tmp2_ = NULL;
	GPastePanel* _tmp3_ = NULL;
	GPastePanel* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GPastePanel* _tmp6_ = NULL;
	GPastePanel* _tmp7_;
	const gchar* _tmp8_ = NULL;
	GPastePanel* _tmp9_ = NULL;
	GPastePanel* _tmp10_;
	const gchar* _tmp11_ = NULL;
	GPastePanel* _tmp12_ = NULL;
	GPastePanel* _tmp13_;
	g_return_if_fail (G_PASTE_IS_WINDOW (self));
	_tmp0_ = g_paste_notebook_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	notebook = _tmp1_;
	_tmp2_ = _ ("General behaviour");
	_tmp3_ = g_paste_window_make_behaviour_panel (self);
	_tmp4_ = _tmp3_;
	g_paste_notebook_add_panel (notebook, _tmp2_, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = _ ("History settings");
	_tmp6_ = g_paste_window_make_history_settings_panel (self);
	_tmp7_ = _tmp6_;
	g_paste_notebook_add_panel (notebook, _tmp5_, _tmp7_);
	_g_object_unref0 (_tmp7_);
	_tmp8_ = _ ("Keyboard shortcuts");
	_tmp9_ = g_paste_window_make_keybindings_panel (self);
	_tmp10_ = _tmp9_;
	g_paste_notebook_add_panel (notebook, _tmp8_, _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = _ ("Histories");
	_tmp12_ = g_paste_window_make_histories_panel (self);
	_tmp13_ = _tmp12_;
	g_paste_notebook_add_panel (notebook, _tmp11_, _tmp13_);
	_g_object_unref0 (_tmp13_);
	gtk_container_add (GTK_CONTAINER (self), GTK_WIDGET (notebook));
	_g_object_unref0 (notebook);
}


static void g_paste_window_class_init (GPasteWindowClass * klass) {
	g_paste_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteWindowPrivate));
	G_OBJECT_CLASS (klass)->finalize = g_paste_window_finalize;
}


static void g_paste_window_instance_init (GPasteWindow * self) {
	self->priv = G_PASTE_WINDOW_GET_PRIVATE (self);
}


static void g_paste_window_finalize (GObject* obj) {
	GPasteWindow * self;
	self = G_PASTE_WINDOW (obj);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->track_changes_button);
	_g_object_unref0 (self->priv->track_extension_state_button);
	_g_object_unref0 (self->priv->primary_to_history_button);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	_g_object_unref0 (self->priv->save_history_button);
	_g_object_unref0 (self->priv->trim_items_button);
	_g_object_unref0 (self->priv->fifo_button);
	_g_object_unref0 (self->priv->max_history_size_button);
	_g_object_unref0 (self->priv->max_displayed_history_size_button);
	_g_object_unref0 (self->priv->element_size_button);
	_g_object_unref0 (self->priv->min_text_item_size_button);
	_g_object_unref0 (self->priv->max_text_item_size_button);
	_g_object_unref0 (self->priv->show_history_entry);
	_g_object_unref0 (self->priv->paste_and_pop_entry);
	_g_object_unref0 (self->priv->backup_entry);
	_g_object_unref0 (self->priv->targets);
	G_OBJECT_CLASS (g_paste_window_parent_class)->finalize (obj);
}


GType g_paste_window_get_type (void) {
	static volatile gsize g_paste_window_type_id__volatile = 0;
	if (g_once_init_enter (&g_paste_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) g_paste_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteWindow), 0, (GInstanceInitFunc) g_paste_window_instance_init, NULL };
		GType g_paste_window_type_id;
		g_paste_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "GPasteWindow", &g_define_type_info, 0);
		g_once_init_leave (&g_paste_window_type_id__volatile, g_paste_window_type_id);
	}
	return g_paste_window_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



