/* gpaste-settings.c generated by valac 0.16.0, the Vala compiler
 * generated from gpaste-settings.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011-2012 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>


#define G_PASTE_TYPE_MAIN (g_paste_main_get_type ())
#define G_PASTE_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_MAIN, GPasteMain))
#define G_PASTE_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_MAIN, GPasteMainClass))
#define G_PASTE_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_MAIN))
#define G_PASTE_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_MAIN))
#define G_PASTE_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_MAIN, GPasteMainClass))

typedef struct _GPasteMain GPasteMain;
typedef struct _GPasteMainClass GPasteMainClass;
typedef struct _GPasteMainPrivate GPasteMainPrivate;

#define G_PASTE_TYPE_DBUS_CLIENT (g_paste_dbus_client_get_type ())
#define G_PASTE_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_DBUS_CLIENT, GPasteDBusClient))
#define G_PASTE_IS_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_DBUS_CLIENT))
#define G_PASTE_DBUS_CLIENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_PASTE_TYPE_DBUS_CLIENT, GPasteDBusClientIface))

typedef struct _GPasteDBusClient GPasteDBusClient;
typedef struct _GPasteDBusClientIface GPasteDBusClientIface;

#define G_PASTE_TYPE_DBUS_CLIENT_PROXY (g_paste_dbus_client_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define G_PASTE_TYPE_WINDOW (g_paste_window_get_type ())
#define G_PASTE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_PASTE_TYPE_WINDOW, GPasteWindow))
#define G_PASTE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_PASTE_TYPE_WINDOW, GPasteWindowClass))
#define G_PASTE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_PASTE_TYPE_WINDOW))
#define G_PASTE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_PASTE_TYPE_WINDOW))
#define G_PASTE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_PASTE_TYPE_WINDOW, GPasteWindowClass))

typedef struct _GPasteWindow GPasteWindow;
typedef struct _GPasteWindowClass GPasteWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GPasteDBusClientIface {
	GTypeInterface parent_iface;
	gchar** (*get_history) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*backup_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*switch_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*delete_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	gchar** (*list_histories) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*add) (GPasteDBusClient* self, const gchar* selection, GError** error);
	gchar* (*get_element) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*select) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*delete) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*empty) (GPasteDBusClient* self, GError** error);
	void (*track) (GPasteDBusClient* self, gboolean tracking_state, GError** error);
	void (*reexec) (GPasteDBusClient* self, GError** error);
};

struct _GPasteMain {
	GtkApplication parent_instance;
	GPasteMainPrivate * priv;
	GPasteDBusClient* gpaste;
};

struct _GPasteMainClass {
	GtkApplicationClass parent_class;
};


static gpointer g_paste_main_parent_class = NULL;

GType g_paste_main_get_type (void) G_GNUC_CONST;
GType g_paste_dbus_client_proxy_get_type (void) G_GNUC_CONST;
guint g_paste_dbus_client_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType g_paste_dbus_client_get_type (void) G_GNUC_CONST;
enum  {
	G_PASTE_MAIN_DUMMY_PROPERTY
};
GPasteMain* g_paste_main_new (void);
GPasteMain* g_paste_main_construct (GType object_type);
static void g_paste_main_init (GPasteMain* self);
static void _g_paste_main_init_g_application_activate (GApplication* _sender, gpointer self);
GPasteWindow* g_paste_window_new (GtkApplication* application);
GPasteWindow* g_paste_window_construct (GType object_type, GtkApplication* application);
GType g_paste_window_get_type (void) G_GNUC_CONST;
gint g_paste_main_main (gchar** args, int args_length1);
static void g_paste_main_finalize (GObject* obj);


static void _g_paste_main_init_g_application_activate (GApplication* _sender, gpointer self) {
	g_paste_main_init (self);
}


GPasteMain* g_paste_main_construct (GType object_type) {
	GPasteMain * self = NULL;
	self = (GPasteMain*) g_object_new (object_type, "application-id", "org.gnome.GPaste.Settings", NULL);
	g_signal_connect_object (G_APPLICATION (self), "activate", (GCallback) _g_paste_main_init_g_application_activate, self, 0);
	return self;
}


GPasteMain* g_paste_main_new (void) {
	return g_paste_main_construct (G_PASTE_TYPE_MAIN);
}


static void g_paste_main_init (GPasteMain* self) {
	GPasteWindow* _tmp0_;
	GPasteWindow* _tmp1_;
	g_return_if_fail (G_PASTE_IS_MAIN (self));
	_tmp0_ = g_paste_window_new (GTK_APPLICATION (self));
	_tmp1_ = g_object_ref_sink (_tmp0_);
	gtk_widget_show_all (GTK_WIDGET (_tmp1_));
	_g_object_unref0 (_tmp1_);
}


gint g_paste_main_main (gchar** args, int args_length1) {
	gint result = 0;
	static const char gettext_package[] = GETTEXT_PACKAGE;
	GtkSettings* _tmp0_ = NULL;
	GPasteMain* _tmp1_;
	GPasteMain* app;
	GPasteMain* _tmp10_;
	gint _tmp11_ = 0;
	GError * _inner_error_ = NULL;
	bindtextdomain (gettext_package, LOCALEDIR);
	bind_textdomain_codeset (gettext_package, "UTF-8");
	textdomain (gettext_package);
	gtk_init (&args_length1, &args);
	_tmp0_ = gtk_settings_get_default ();
	g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", TRUE, NULL);
	_tmp1_ = g_paste_main_new ();
	app = _tmp1_;
	{
		GPasteDBusClient* _tmp2_ = NULL;
		GPasteDBusClient* _tmp3_;
		GPasteMain* _tmp4_;
		GPasteMain* _tmp5_;
		_tmp2_ = g_initable_new (G_PASTE_TYPE_DBUS_CLIENT_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.gnome.GPaste", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/GPaste", "g-interface-name", "org.gnome.GPaste", NULL);
		_tmp3_ = (GPasteDBusClient*) _tmp2_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			goto __catch0_g_error;
		}
		_tmp4_ = app;
		_g_object_unref0 (_tmp4_->gpaste);
		_tmp4_->gpaste = _tmp3_;
		_tmp5_ = app;
		g_application_register (G_APPLICATION (_tmp5_), NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = stderr;
		_tmp7_ = _ ("Couldn't connect to GPaste daemon.\n");
		fprintf (_tmp6_, "%s", _tmp7_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp8_;
		const gchar* _tmp9_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = stderr;
		_tmp9_ = _ ("Fail to register the gtk application.\n");
		fprintf (_tmp8_, "%s", _tmp9_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (app);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp10_ = app;
	_tmp11_ = g_application_run (G_APPLICATION (_tmp10_), 0, NULL);
	result = _tmp11_;
	_g_object_unref0 (app);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return g_paste_main_main (argv, argc);
}


static void g_paste_main_class_init (GPasteMainClass * klass) {
	g_paste_main_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = g_paste_main_finalize;
}


static void g_paste_main_instance_init (GPasteMain * self) {
}


static void g_paste_main_finalize (GObject* obj) {
	GPasteMain * self;
	self = G_PASTE_MAIN (obj);
	_g_object_unref0 (self->gpaste);
	G_OBJECT_CLASS (g_paste_main_parent_class)->finalize (obj);
}


GType g_paste_main_get_type (void) {
	static volatile gsize g_paste_main_type_id__volatile = 0;
	if (g_once_init_enter (&g_paste_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) g_paste_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteMain), 0, (GInstanceInitFunc) g_paste_main_instance_init, NULL };
		GType g_paste_main_type_id;
		g_paste_main_type_id = g_type_register_static (GTK_TYPE_APPLICATION, "GPasteMain", &g_define_type_info, 0);
		g_once_init_leave (&g_paste_main_type_id__volatile, g_paste_main_type_id);
	}
	return g_paste_main_type_id__volatile;
}



