/* gpaste.c generated by valac 0.16.0, the Vala compiler
 * generated from gpaste.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011-2012 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <locale.h>
#include <unistd.h>


#define GPASTE_CLIENT_TYPE_MAIN (gpaste_client_main_get_type ())
#define GPASTE_CLIENT_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_CLIENT_TYPE_MAIN, GPasteClientMain))
#define GPASTE_CLIENT_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_CLIENT_TYPE_MAIN, GPasteClientMainClass))
#define GPASTE_CLIENT_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_CLIENT_TYPE_MAIN))
#define GPASTE_CLIENT_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_CLIENT_TYPE_MAIN))
#define GPASTE_CLIENT_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_CLIENT_TYPE_MAIN, GPasteClientMainClass))

typedef struct _GPasteClientMain GPasteClientMain;
typedef struct _GPasteClientMainClass GPasteClientMainClass;
typedef struct _GPasteClientMainPrivate GPasteClientMainPrivate;

#define GPASTE_TYPE_DBUS_CLIENT (gpaste_dbus_client_get_type ())
#define GPASTE_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_TYPE_DBUS_CLIENT, GPasteDBusClient))
#define GPASTE_IS_DBUS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_TYPE_DBUS_CLIENT))
#define GPASTE_DBUS_CLIENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GPASTE_TYPE_DBUS_CLIENT, GPasteDBusClientIface))

typedef struct _GPasteDBusClient GPasteDBusClient;
typedef struct _GPasteDBusClientIface GPasteDBusClientIface;

#define GPASTE_TYPE_DBUS_CLIENT_PROXY (gpaste_dbus_client_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GPasteClientMain {
	GObject parent_instance;
	GPasteClientMainPrivate * priv;
};

struct _GPasteClientMainClass {
	GObjectClass parent_class;
};

struct _GPasteDBusClientIface {
	GTypeInterface parent_iface;
	gchar** (*get_history) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*backup_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*switch_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	void (*delete_history) (GPasteDBusClient* self, const gchar* name, GError** error);
	gchar** (*list_histories) (GPasteDBusClient* self, int* result_length1, GError** error);
	void (*add) (GPasteDBusClient* self, const gchar* selection, GError** error);
	gchar* (*get_element) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*select) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*delete) (GPasteDBusClient* self, guint32 pos, GError** error);
	void (*empty) (GPasteDBusClient* self, GError** error);
	void (*track) (GPasteDBusClient* self, gboolean tracking_state, GError** error);
	void (*reexec) (GPasteDBusClient* self, GError** error);
};

struct _GPasteClientMainPrivate {
	GPasteDBusClient* gpaste;
};


static gpointer gpaste_client_main_parent_class = NULL;

GType gpaste_client_main_get_type (void) G_GNUC_CONST;
GType gpaste_dbus_client_proxy_get_type (void) G_GNUC_CONST;
guint gpaste_dbus_client_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType gpaste_dbus_client_get_type (void) G_GNUC_CONST;
#define GPASTE_CLIENT_MAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_CLIENT_TYPE_MAIN, GPasteClientMainPrivate))
enum  {
	GPASTE_CLIENT_MAIN_DUMMY_PROPERTY
};
static void gpaste_client_main_usage (GPasteClientMain* self, const gchar* caller);
static void gpaste_client_main_history (GPasteClientMain* self, gboolean raw, gboolean zero, GError** error);
gchar** gpaste_dbus_client_get_history (GPasteDBusClient* self, int* result_length1, GError** error);
gint gpaste_client_main_main (gchar** args, int args_length1);
GPasteClientMain* gpaste_client_main_new (void);
GPasteClientMain* gpaste_client_main_construct (GType object_type);
void gpaste_dbus_client_add (GPasteDBusClient* self, const gchar* selection, GError** error);
void gpaste_dbus_client_track (GPasteDBusClient* self, gboolean tracking_state, GError** error);
void gpaste_dbus_client_empty (GPasteDBusClient* self, GError** error);
void gpaste_dbus_client_reexec (GPasteDBusClient* self, GError** error);
gchar** gpaste_dbus_client_list_histories (GPasteDBusClient* self, int* result_length1, GError** error);
void gpaste_dbus_client_backup_history (GPasteDBusClient* self, const gchar* name, GError** error);
void gpaste_dbus_client_switch_history (GPasteDBusClient* self, const gchar* name, GError** error);
void gpaste_dbus_client_delete_history (GPasteDBusClient* self, const gchar* name, GError** error);
gchar* gpaste_dbus_client_get_element (GPasteDBusClient* self, guint32 pos, GError** error);
void gpaste_dbus_client_select (GPasteDBusClient* self, guint32 pos, GError** error);
void gpaste_dbus_client_delete (GPasteDBusClient* self, guint32 pos, GError** error);
static void gpaste_client_main_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static void gpaste_client_main_usage (GPasteClientMain* self, const gchar* caller) {
	FILE* _tmp0_;
	const gchar* _tmp1_ = NULL;
	FILE* _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	FILE* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	FILE* _tmp8_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	FILE* _tmp11_;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_;
	FILE* _tmp14_;
	const gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	FILE* _tmp17_;
	const gchar* _tmp18_ = NULL;
	const gchar* _tmp19_;
	FILE* _tmp20_;
	const gchar* _tmp21_ = NULL;
	const gchar* _tmp22_;
	FILE* _tmp23_;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	FILE* _tmp26_;
	const gchar* _tmp27_ = NULL;
	const gchar* _tmp28_;
	FILE* _tmp29_;
	const gchar* _tmp30_ = NULL;
	const gchar* _tmp31_;
	FILE* _tmp32_;
	const gchar* _tmp33_ = NULL;
	const gchar* _tmp34_;
	FILE* _tmp35_;
	const gchar* _tmp36_ = NULL;
	const gchar* _tmp37_;
	FILE* _tmp38_;
	const gchar* _tmp39_ = NULL;
	const gchar* _tmp40_;
	FILE* _tmp41_;
	const gchar* _tmp42_ = NULL;
	const gchar* _tmp43_;
	FILE* _tmp44_;
	const gchar* _tmp45_ = NULL;
	const gchar* _tmp46_;
	FILE* _tmp47_;
	const gchar* _tmp48_ = NULL;
	const gchar* _tmp49_;
	FILE* _tmp50_;
	const gchar* _tmp51_ = NULL;
	const gchar* _tmp52_;
	FILE* _tmp53_;
	const gchar* _tmp54_ = NULL;
	const gchar* _tmp55_;
	FILE* _tmp56_;
	const gchar* _tmp57_ = NULL;
	const gchar* _tmp58_;
	FILE* _tmp59_;
	const gchar* _tmp60_ = NULL;
	const gchar* _tmp61_;
	FILE* _tmp62_;
	const gchar* _tmp63_ = NULL;
	const gchar* _tmp64_;
	g_return_if_fail (GPASTE_CLIENT_IS_MAIN (self));
	g_return_if_fail (caller != NULL);
	_tmp0_ = stdout;
	_tmp1_ = _ ("Usage:\n");
	fprintf (_tmp0_, "%s", _tmp1_);
	_tmp2_ = stdout;
	_tmp3_ = _ ("%s [history]: print the history with indexes\n");
	_tmp4_ = caller;
	fprintf (_tmp2_, _tmp3_, _tmp4_);
	_tmp5_ = stdout;
	_tmp6_ = _ ("%s backup-history <name>: backup current history\n");
	_tmp7_ = caller;
	fprintf (_tmp5_, _tmp6_, _tmp7_);
	_tmp8_ = stdout;
	_tmp9_ = _ ("%s switch-history <name>: switch to another history\n");
	_tmp10_ = caller;
	fprintf (_tmp8_, _tmp9_, _tmp10_);
	_tmp11_ = stdout;
	_tmp12_ = _ ("%s delete-history <name>: delete a history\n");
	_tmp13_ = caller;
	fprintf (_tmp11_, _tmp12_, _tmp13_);
	_tmp14_ = stdout;
	_tmp15_ = _ ("%s list-histories: list available histories\n");
	_tmp16_ = caller;
	fprintf (_tmp14_, _tmp15_, _tmp16_);
	_tmp17_ = stdout;
	_tmp18_ = _ ("%s raw-history: print the history without indexes\n");
	_tmp19_ = caller;
	fprintf (_tmp17_, _tmp18_, _tmp19_);
	_tmp20_ = stdout;
	_tmp21_ = _ ("%s zero-history: print the history with NUL as separator\n");
	_tmp22_ = caller;
	fprintf (_tmp20_, _tmp21_, _tmp22_);
	_tmp23_ = stdout;
	_tmp24_ = _ ("%s add <text>: set text to clipboard\n");
	_tmp25_ = caller;
	fprintf (_tmp23_, _tmp24_, _tmp25_);
	_tmp26_ = stdout;
	_tmp27_ = _ ("%s get <number>: get the <number>th item from the history\n");
	_tmp28_ = caller;
	fprintf (_tmp26_, _tmp27_, _tmp28_);
	_tmp29_ = stdout;
	_tmp30_ = _ ("%s set <number>: set the <number>th item from the history to the clipb" \
"oard\n");
	_tmp31_ = caller;
	fprintf (_tmp29_, _tmp30_, _tmp31_);
	_tmp32_ = stdout;
	_tmp33_ = _ ("%s delete <number>: delete <number>th item of the history\n");
	_tmp34_ = caller;
	fprintf (_tmp32_, _tmp33_, _tmp34_);
	_tmp35_ = stdout;
	_tmp36_ = _ ("%s file <path>: put the content of the file at <path> into the clipboa" \
"rd\n");
	_tmp37_ = caller;
	fprintf (_tmp35_, _tmp36_, _tmp37_);
	_tmp38_ = stdout;
	_tmp39_ = _ ("whatever | %s: set the output of whatever to clipboard\n");
	_tmp40_ = caller;
	fprintf (_tmp38_, _tmp39_, _tmp40_);
	_tmp41_ = stdout;
	_tmp42_ = _ ("%s empty: empty the history\n");
	_tmp43_ = caller;
	fprintf (_tmp41_, _tmp42_, _tmp43_);
	_tmp44_ = stdout;
	_tmp45_ = _ ("%s start: start tracking clipboard changes\n");
	_tmp46_ = caller;
	fprintf (_tmp44_, _tmp45_, _tmp46_);
	_tmp47_ = stdout;
	_tmp48_ = _ ("%s stop: stop tracking clipboard changes\n");
	_tmp49_ = caller;
	fprintf (_tmp47_, _tmp48_, _tmp49_);
	_tmp50_ = stdout;
	_tmp51_ = _ ("%s quit: alias for stop\n");
	_tmp52_ = caller;
	fprintf (_tmp50_, _tmp51_, _tmp52_);
	_tmp53_ = stdout;
	_tmp54_ = _ ("%s daemon-reexec: reexecute the daemon (after upgrading...)\n");
	_tmp55_ = caller;
	fprintf (_tmp53_, _tmp54_, _tmp55_);
	_tmp56_ = stdout;
	_tmp57_ = _ ("%s settings: launch the configuration tool\n");
	_tmp58_ = caller;
	fprintf (_tmp56_, _tmp57_, _tmp58_);
	_tmp59_ = stdout;
	_tmp60_ = _ ("%s version: display the version\n");
	_tmp61_ = caller;
	fprintf (_tmp59_, _tmp60_, _tmp61_);
	_tmp62_ = stdout;
	_tmp63_ = _ ("%s help: display this help\n");
	_tmp64_ = caller;
	fprintf (_tmp62_, _tmp63_, _tmp64_);
}


static void gpaste_client_main_history (GPasteClientMain* self, gboolean raw, gboolean zero, GError** error) {
	GPasteDBusClient* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_ = NULL;
	gchar** history;
	gint history_length1;
	gint _history_size_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (GPASTE_CLIENT_IS_MAIN (self));
	_tmp0_ = self->priv->gpaste;
	_tmp2_ = gpaste_dbus_client_get_history (_tmp0_, &_tmp1_, &_inner_error_);
	history = _tmp2_;
	history_length1 = _tmp1_;
	_history_size_ = history_length1;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		gint i;
		i = 0;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_;
				gint _tmp6_;
				gboolean _tmp7_;
				FILE* _tmp10_;
				gint _tmp11_;
				const gchar* _tmp12_;
				gboolean _tmp13_;
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = i;
				if (!(_tmp6_ < history_length1)) {
					break;
				}
				_tmp7_ = raw;
				if (!_tmp7_) {
					FILE* _tmp8_;
					gint _tmp9_;
					_tmp8_ = stdout;
					_tmp9_ = i;
					fprintf (_tmp8_, "%d: ", _tmp9_);
				}
				_tmp10_ = stdout;
				_tmp11_ = i;
				_tmp12_ = history[_tmp11_];
				fprintf (_tmp10_, "%s", _tmp12_);
				_tmp13_ = zero;
				if (_tmp13_) {
					FILE* _tmp14_;
					_tmp14_ = stdout;
					fputc ('\0', _tmp14_);
				} else {
					FILE* _tmp15_;
					_tmp15_ = stdout;
					fputc ('\n', _tmp15_);
				}
			}
		}
	}
	history = (_vala_array_free (history, history_length1, (GDestroyNotify) g_free), NULL);
}


static gchar* g_file_stream_read_line (FILE* self) {
	gchar* result = NULL;
	gint c = 0;
	GString* ret;
	GString* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	ret = NULL;
	while (TRUE) {
		gint _tmp0_ = 0;
		gint _tmp1_;
		GString* _tmp2_;
		gint _tmp4_;
		GString* _tmp5_;
		gint _tmp6_;
		_tmp0_ = fgetc (self);
		c = _tmp0_;
		_tmp1_ = c;
		if (!(_tmp1_ != EOF)) {
			break;
		}
		_tmp2_ = ret;
		if (_tmp2_ == NULL) {
			GString* _tmp3_;
			_tmp3_ = g_string_new ("");
			_g_string_free0 (ret);
			ret = _tmp3_;
		}
		_tmp4_ = c;
		if (_tmp4_ == ((gint) '\n')) {
			break;
		}
		_tmp5_ = ret;
		_tmp6_ = c;
		g_string_append_c ((GString*) _tmp5_, (gchar) _tmp6_);
	}
	_tmp7_ = ret;
	if (_tmp7_ == NULL) {
		result = NULL;
		_g_string_free0 (ret);
		return result;
	} else {
		GString* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp8_ = ret;
		_tmp9_ = ((GString*) _tmp8_)->str;
		_tmp10_ = g_strdup (_tmp9_);
		result = _tmp10_;
		_g_string_free0 (ret);
		return result;
	}
	_g_string_free0 (ret);
}


gint gpaste_client_main_main (gchar** args, int args_length1) {
	gint result = 0;
	static const char gettext_package[] = GETTEXT_PACKAGE;
	GPasteClientMain* _tmp0_;
	GPasteClientMain* app;
	GError * _inner_error_ = NULL;
	bindtextdomain (gettext_package, LOCALEDIR);
	bind_textdomain_codeset (gettext_package, "UTF-8");
	textdomain (gettext_package);
	setlocale (LC_ALL, "");
	_tmp0_ = gpaste_client_main_new ();
	app = _tmp0_;
	{
		GPasteDBusClient* _tmp1_ = NULL;
		GPasteDBusClient* _tmp2_;
		GPasteClientMain* _tmp3_;
		FILE* _tmp4_;
		gint _tmp5_ = 0;
		gboolean _tmp6_ = FALSE;
		_tmp1_ = g_initable_new (GPASTE_TYPE_DBUS_CLIENT_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.gnome.GPaste", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/GPaste", "g-interface-name", "org.gnome.GPaste", NULL);
		_tmp2_ = (GPasteDBusClient*) _tmp1_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			_g_object_unref0 (app);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		_tmp3_ = app;
		_g_object_unref0 (_tmp3_->priv->gpaste);
		_tmp3_->priv->gpaste = _tmp2_;
		_tmp4_ = stdin;
		_tmp5_ = fileno (_tmp4_);
		_tmp6_ = isatty (_tmp5_);
		if (!_tmp6_) {
			GString* _tmp7_;
			GString* text;
			FILE* _tmp8_;
			gchar* _tmp9_ = NULL;
			gchar* line;
			const gchar* _tmp10_;
			GPasteClientMain* _tmp19_;
			GPasteDBusClient* _tmp20_;
			GString* _tmp21_;
			const gchar* _tmp22_;
			_tmp7_ = g_string_new ("");
			text = _tmp7_;
			_tmp8_ = stdin;
			_tmp9_ = g_file_stream_read_line (_tmp8_);
			line = _tmp9_;
			_tmp10_ = line;
			if (_tmp10_ != NULL) {
				GString* _tmp11_;
				const gchar* _tmp12_;
				_tmp11_ = text;
				_tmp12_ = line;
				g_string_append (_tmp11_, (const gchar*) _tmp12_);
			}
			while (TRUE) {
				FILE* _tmp13_;
				gchar* _tmp14_ = NULL;
				const gchar* _tmp15_;
				GString* _tmp16_;
				GString* _tmp17_ = NULL;
				const gchar* _tmp18_;
				_tmp13_ = stdin;
				_tmp14_ = g_file_stream_read_line (_tmp13_);
				_g_free0 (line);
				line = _tmp14_;
				_tmp15_ = line;
				if (!(_tmp15_ != NULL)) {
					break;
				}
				_tmp16_ = text;
				_tmp17_ = g_string_append_c (_tmp16_, '\n');
				_tmp18_ = line;
				g_string_append (_tmp17_, (const gchar*) _tmp18_);
			}
			_tmp19_ = app;
			_tmp20_ = _tmp19_->priv->gpaste;
			_tmp21_ = text;
			_tmp22_ = _tmp21_->str;
			gpaste_dbus_client_add (_tmp20_, _tmp22_, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_free0 (line);
				_g_string_free0 (text);
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				_g_free0 (line);
				_g_string_free0 (text);
				_g_object_unref0 (app);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return 0;
			}
			_g_free0 (line);
			_g_string_free0 (text);
		} else {
			gchar** _tmp23_;
			gint _tmp23__length1;
			_tmp23_ = args;
			_tmp23__length1 = args_length1;
			switch (_tmp23__length1) {
				case 1:
				{
					GPasteClientMain* _tmp24_;
					_tmp24_ = app;
					gpaste_client_main_history (_tmp24_, FALSE, FALSE, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_IO_ERROR) {
							goto __catch0_g_io_error;
						}
						_g_object_unref0 (app);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return 0;
					}
					break;
				}
				case 2:
				{
					gchar** _tmp25_;
					gint _tmp25__length1;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					GQuark _tmp29_ = 0U;
					static GQuark _tmp28_label0 = 0;
					static GQuark _tmp28_label1 = 0;
					static GQuark _tmp28_label2 = 0;
					static GQuark _tmp28_label3 = 0;
					static GQuark _tmp28_label4 = 0;
					static GQuark _tmp28_label5 = 0;
					static GQuark _tmp28_label6 = 0;
					static GQuark _tmp28_label7 = 0;
					static GQuark _tmp28_label8 = 0;
					static GQuark _tmp28_label9 = 0;
					static GQuark _tmp28_label10 = 0;
					static GQuark _tmp28_label11 = 0;
					static GQuark _tmp28_label12 = 0;
					static GQuark _tmp28_label13 = 0;
					static GQuark _tmp28_label14 = 0;
					static GQuark _tmp28_label15 = 0;
					static GQuark _tmp28_label16 = 0;
					static GQuark _tmp28_label17 = 0;
					static GQuark _tmp28_label18 = 0;
					static GQuark _tmp28_label19 = 0;
					static GQuark _tmp28_label20 = 0;
					static GQuark _tmp28_label21 = 0;
					static GQuark _tmp28_label22 = 0;
					static GQuark _tmp28_label23 = 0;
					static GQuark _tmp28_label24 = 0;
					static GQuark _tmp28_label25 = 0;
					static GQuark _tmp28_label26 = 0;
					static GQuark _tmp28_label27 = 0;
					static GQuark _tmp28_label28 = 0;
					static GQuark _tmp28_label29 = 0;
					_tmp25_ = args;
					_tmp25__length1 = args_length1;
					_tmp26_ = _tmp25_[1];
					_tmp27_ = _tmp26_;
					_tmp29_ = (NULL == _tmp27_) ? 0 : g_quark_from_string (_tmp27_);
					if (((_tmp29_ == ((0 != _tmp28_label0) ? _tmp28_label0 : (_tmp28_label0 = g_quark_from_static_string ("help")))) || (_tmp29_ == ((0 != _tmp28_label1) ? _tmp28_label1 : (_tmp28_label1 = g_quark_from_static_string ("-h"))))) || (_tmp29_ == ((0 != _tmp28_label2) ? _tmp28_label2 : (_tmp28_label2 = g_quark_from_static_string ("--help"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp30_;
								gchar** _tmp31_;
								gint _tmp31__length1;
								const gchar* _tmp32_;
								_tmp30_ = app;
								_tmp31_ = args;
								_tmp31__length1 = args_length1;
								_tmp32_ = _tmp31_[0];
								gpaste_client_main_usage (_tmp30_, _tmp32_);
								break;
							}
						}
					} else if (((_tmp29_ == ((0 != _tmp28_label3) ? _tmp28_label3 : (_tmp28_label3 = g_quark_from_static_string ("start")))) || (_tmp29_ == ((0 != _tmp28_label4) ? _tmp28_label4 : (_tmp28_label4 = g_quark_from_static_string ("d"))))) || (_tmp29_ == ((0 != _tmp28_label5) ? _tmp28_label5 : (_tmp28_label5 = g_quark_from_static_string ("daemon"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp33_;
								GPasteDBusClient* _tmp34_;
								_tmp33_ = app;
								_tmp34_ = _tmp33_->priv->gpaste;
								gpaste_dbus_client_track (_tmp34_, TRUE, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if (((_tmp29_ == ((0 != _tmp28_label6) ? _tmp28_label6 : (_tmp28_label6 = g_quark_from_static_string ("stop")))) || (_tmp29_ == ((0 != _tmp28_label7) ? _tmp28_label7 : (_tmp28_label7 = g_quark_from_static_string ("q"))))) || (_tmp29_ == ((0 != _tmp28_label8) ? _tmp28_label8 : (_tmp28_label8 = g_quark_from_static_string ("quit"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp35_;
								GPasteDBusClient* _tmp36_;
								_tmp35_ = app;
								_tmp36_ = _tmp35_->priv->gpaste;
								gpaste_dbus_client_track (_tmp36_, FALSE, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp29_ == ((0 != _tmp28_label9) ? _tmp28_label9 : (_tmp28_label9 = g_quark_from_static_string ("e")))) || (_tmp29_ == ((0 != _tmp28_label10) ? _tmp28_label10 : (_tmp28_label10 = g_quark_from_static_string ("empty"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp37_;
								GPasteDBusClient* _tmp38_;
								_tmp37_ = app;
								_tmp38_ = _tmp37_->priv->gpaste;
								gpaste_dbus_client_empty (_tmp38_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((((_tmp29_ == ((0 != _tmp28_label11) ? _tmp28_label11 : (_tmp28_label11 = g_quark_from_static_string ("v")))) || (_tmp29_ == ((0 != _tmp28_label12) ? _tmp28_label12 : (_tmp28_label12 = g_quark_from_static_string ("version"))))) || (_tmp29_ == ((0 != _tmp28_label13) ? _tmp28_label13 : (_tmp28_label13 = g_quark_from_static_string ("-v"))))) || (_tmp29_ == ((0 != _tmp28_label14) ? _tmp28_label14 : (_tmp28_label14 = g_quark_from_static_string ("--version"))))) {
						switch (0) {
							default:
							{
								FILE* _tmp39_;
								_tmp39_ = stdout;
								fprintf (_tmp39_, "%s", PACKAGE_STRING "\n");
								break;
							}
						}
					} else if (_tmp29_ == ((0 != _tmp28_label15) ? _tmp28_label15 : (_tmp28_label15 = g_quark_from_static_string ("applet")))) {
						switch (0) {
							default:
							{
								{
									g_spawn_command_line_async (PKGLIBEXECDIR "/gpaste-applet", &_inner_error_);
									if (_inner_error_ != NULL) {
										if (_inner_error_->domain == G_SPAWN_ERROR) {
											goto __catch1_g_spawn_error;
										}
										_g_object_unref0 (app);
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return 0;
									}
								}
								goto __finally1;
								__catch1_g_spawn_error:
								{
									GError* e = NULL;
									FILE* _tmp40_;
									const gchar* _tmp41_ = NULL;
									e = _inner_error_;
									_inner_error_ = NULL;
									_tmp40_ = stderr;
									_tmp41_ = _ ("Couldn't spawn gpaste-applet.\n");
									fprintf (_tmp40_, "%s", _tmp41_);
									_g_error_free0 (e);
								}
								__finally1:
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((((_tmp29_ == ((0 != _tmp28_label16) ? _tmp28_label16 : (_tmp28_label16 = g_quark_from_static_string ("s")))) || (_tmp29_ == ((0 != _tmp28_label17) ? _tmp28_label17 : (_tmp28_label17 = g_quark_from_static_string ("settings"))))) || (_tmp29_ == ((0 != _tmp28_label18) ? _tmp28_label18 : (_tmp28_label18 = g_quark_from_static_string ("p"))))) || (_tmp29_ == ((0 != _tmp28_label19) ? _tmp28_label19 : (_tmp28_label19 = g_quark_from_static_string ("preferences"))))) {
						switch (0) {
							default:
							{
								execl (PKGLIBEXECDIR "/gpaste-settings", "GPaste-Settings", NULL);
								break;
							}
						}
					} else if ((_tmp29_ == ((0 != _tmp28_label20) ? _tmp28_label20 : (_tmp28_label20 = g_quark_from_static_string ("dr")))) || (_tmp29_ == ((0 != _tmp28_label21) ? _tmp28_label21 : (_tmp28_label21 = g_quark_from_static_string ("daemon-reexec"))))) {
						switch (0) {
							default:
							{
								{
									GPasteClientMain* _tmp42_;
									GPasteDBusClient* _tmp43_;
									_tmp42_ = app;
									_tmp43_ = _tmp42_->priv->gpaste;
									gpaste_dbus_client_reexec (_tmp43_, &_inner_error_);
									if (_inner_error_ != NULL) {
										goto __catch2_g_error;
									}
								}
								goto __finally2;
								__catch2_g_error:
								{
									GError* e = NULL;
									GError* _tmp44_;
									gint _tmp45_;
									e = _inner_error_;
									_inner_error_ = NULL;
									_tmp44_ = e;
									_tmp45_ = _tmp44_->code;
									if (_tmp45_ == 4) {
										FILE* _tmp46_;
										const gchar* _tmp47_ = NULL;
										_tmp46_ = stdout;
										_tmp47_ = _ ("Successfully reexecuted the daemon\n");
										fprintf (_tmp46_, "%s", _tmp47_);
									} else {
										GError* _tmp48_;
										const gchar* _tmp49_;
										GError* _tmp50_;
										GQuark _tmp51_;
										const gchar* _tmp52_ = NULL;
										GError* _tmp53_;
										gint _tmp54_;
										_tmp48_ = e;
										_tmp49_ = _tmp48_->message;
										_tmp50_ = e;
										_tmp51_ = _tmp50_->domain;
										_tmp52_ = g_quark_to_string (_tmp51_);
										_tmp53_ = e;
										_tmp54_ = _tmp53_->code;
										g_critical ("gpaste.vala:138: %s (%s, %d)", _tmp49_, _tmp52_, _tmp54_);
									}
									_g_error_free0 (e);
								}
								__finally2:
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp29_ == ((0 != _tmp28_label22) ? _tmp28_label22 : (_tmp28_label22 = g_quark_from_static_string ("h")))) || (_tmp29_ == ((0 != _tmp28_label23) ? _tmp28_label23 : (_tmp28_label23 = g_quark_from_static_string ("history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp55_;
								_tmp55_ = app;
								gpaste_client_main_history (_tmp55_, FALSE, FALSE, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp29_ == ((0 != _tmp28_label24) ? _tmp28_label24 : (_tmp28_label24 = g_quark_from_static_string ("rh")))) || (_tmp29_ == ((0 != _tmp28_label25) ? _tmp28_label25 : (_tmp28_label25 = g_quark_from_static_string ("raw-history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp56_;
								_tmp56_ = app;
								gpaste_client_main_history (_tmp56_, TRUE, FALSE, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp29_ == ((0 != _tmp28_label26) ? _tmp28_label26 : (_tmp28_label26 = g_quark_from_static_string ("zh")))) || (_tmp29_ == ((0 != _tmp28_label27) ? _tmp28_label27 : (_tmp28_label27 = g_quark_from_static_string ("zero-history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp57_;
								_tmp57_ = app;
								gpaste_client_main_history (_tmp57_, FALSE, TRUE, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp29_ == ((0 != _tmp28_label28) ? _tmp28_label28 : (_tmp28_label28 = g_quark_from_static_string ("lh")))) || (_tmp29_ == ((0 != _tmp28_label29) ? _tmp28_label29 : (_tmp28_label29 = g_quark_from_static_string ("list-history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp58_;
								GPasteDBusClient* _tmp59_;
								gint _tmp60_ = 0;
								gchar** _tmp61_ = NULL;
								gchar** history_names;
								gint history_names_length1;
								gint _history_names_size_;
								_tmp58_ = app;
								_tmp59_ = _tmp58_->priv->gpaste;
								_tmp61_ = gpaste_dbus_client_list_histories (_tmp59_, &_tmp60_, &_inner_error_);
								history_names = _tmp61_;
								history_names_length1 = _tmp60_;
								_history_names_size_ = history_names_length1;
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								{
									gint i;
									i = 0;
									{
										gboolean _tmp62_;
										_tmp62_ = TRUE;
										while (TRUE) {
											gboolean _tmp63_;
											gint _tmp65_;
											gchar** _tmp66_;
											gint _tmp66__length1;
											FILE* _tmp67_;
											gchar** _tmp68_;
											gint _tmp68__length1;
											gint _tmp69_;
											const gchar* _tmp70_;
											_tmp63_ = _tmp62_;
											if (!_tmp63_) {
												gint _tmp64_;
												_tmp64_ = i;
												i = _tmp64_ + 1;
											}
											_tmp62_ = FALSE;
											_tmp65_ = i;
											_tmp66_ = history_names;
											_tmp66__length1 = history_names_length1;
											if (!(_tmp65_ < _tmp66__length1)) {
												break;
											}
											_tmp67_ = stdout;
											_tmp68_ = history_names;
											_tmp68__length1 = history_names_length1;
											_tmp69_ = i;
											_tmp70_ = _tmp68_[_tmp69_];
											fprintf (_tmp67_, "%s\n", _tmp70_);
										}
									}
								}
								history_names = (_vala_array_free (history_names, history_names_length1, (GDestroyNotify) g_free), NULL);
								break;
							}
						}
					} else {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp71_;
								gchar** _tmp72_;
								gint _tmp72__length1;
								const gchar* _tmp73_;
								_tmp71_ = app;
								_tmp72_ = args;
								_tmp72__length1 = args_length1;
								_tmp73_ = _tmp72_[0];
								gpaste_client_main_usage (_tmp71_, _tmp73_);
								break;
							}
						}
					}
					break;
				}
				case 3:
				{
					gchar** _tmp74_;
					gint _tmp74__length1;
					const gchar* _tmp75_;
					const gchar* _tmp76_;
					GQuark _tmp78_ = 0U;
					static GQuark _tmp77_label0 = 0;
					static GQuark _tmp77_label1 = 0;
					static GQuark _tmp77_label2 = 0;
					static GQuark _tmp77_label3 = 0;
					static GQuark _tmp77_label4 = 0;
					static GQuark _tmp77_label5 = 0;
					static GQuark _tmp77_label6 = 0;
					static GQuark _tmp77_label7 = 0;
					static GQuark _tmp77_label8 = 0;
					static GQuark _tmp77_label9 = 0;
					static GQuark _tmp77_label10 = 0;
					static GQuark _tmp77_label11 = 0;
					static GQuark _tmp77_label12 = 0;
					static GQuark _tmp77_label13 = 0;
					static GQuark _tmp77_label14 = 0;
					static GQuark _tmp77_label15 = 0;
					static GQuark _tmp77_label16 = 0;
					static GQuark _tmp77_label17 = 0;
					_tmp74_ = args;
					_tmp74__length1 = args_length1;
					_tmp75_ = _tmp74_[1];
					_tmp76_ = _tmp75_;
					_tmp78_ = (NULL == _tmp76_) ? 0 : g_quark_from_string (_tmp76_);
					if ((_tmp78_ == ((0 != _tmp77_label0) ? _tmp77_label0 : (_tmp77_label0 = g_quark_from_static_string ("bh")))) || (_tmp78_ == ((0 != _tmp77_label1) ? _tmp77_label1 : (_tmp77_label1 = g_quark_from_static_string ("backup-history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp79_;
								GPasteDBusClient* _tmp80_;
								gchar** _tmp81_;
								gint _tmp81__length1;
								const gchar* _tmp82_;
								_tmp79_ = app;
								_tmp80_ = _tmp79_->priv->gpaste;
								_tmp81_ = args;
								_tmp81__length1 = args_length1;
								_tmp82_ = _tmp81_[2];
								gpaste_dbus_client_backup_history (_tmp80_, _tmp82_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label2) ? _tmp77_label2 : (_tmp77_label2 = g_quark_from_static_string ("sh")))) || (_tmp78_ == ((0 != _tmp77_label3) ? _tmp77_label3 : (_tmp77_label3 = g_quark_from_static_string ("switch-history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp83_;
								GPasteDBusClient* _tmp84_;
								gchar** _tmp85_;
								gint _tmp85__length1;
								const gchar* _tmp86_;
								_tmp83_ = app;
								_tmp84_ = _tmp83_->priv->gpaste;
								_tmp85_ = args;
								_tmp85__length1 = args_length1;
								_tmp86_ = _tmp85_[2];
								gpaste_dbus_client_switch_history (_tmp84_, _tmp86_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label4) ? _tmp77_label4 : (_tmp77_label4 = g_quark_from_static_string ("dh")))) || (_tmp78_ == ((0 != _tmp77_label5) ? _tmp77_label5 : (_tmp77_label5 = g_quark_from_static_string ("delete-history"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp87_;
								GPasteDBusClient* _tmp88_;
								gchar** _tmp89_;
								gint _tmp89__length1;
								const gchar* _tmp90_;
								_tmp87_ = app;
								_tmp88_ = _tmp87_->priv->gpaste;
								_tmp89_ = args;
								_tmp89__length1 = args_length1;
								_tmp90_ = _tmp89_[2];
								gpaste_dbus_client_delete_history (_tmp88_, _tmp90_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label6) ? _tmp77_label6 : (_tmp77_label6 = g_quark_from_static_string ("a")))) || (_tmp78_ == ((0 != _tmp77_label7) ? _tmp77_label7 : (_tmp77_label7 = g_quark_from_static_string ("add"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp91_;
								GPasteDBusClient* _tmp92_;
								gchar** _tmp93_;
								gint _tmp93__length1;
								const gchar* _tmp94_;
								_tmp91_ = app;
								_tmp92_ = _tmp91_->priv->gpaste;
								_tmp93_ = args;
								_tmp93__length1 = args_length1;
								_tmp94_ = _tmp93_[2];
								gpaste_dbus_client_add (_tmp92_, _tmp94_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label8) ? _tmp77_label8 : (_tmp77_label8 = g_quark_from_static_string ("g")))) || (_tmp78_ == ((0 != _tmp77_label9) ? _tmp77_label9 : (_tmp77_label9 = g_quark_from_static_string ("get"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp95_;
								GPasteDBusClient* _tmp96_;
								gchar** _tmp97_;
								gint _tmp97__length1;
								const gchar* _tmp98_;
								gint _tmp99_ = 0;
								gchar* _tmp100_ = NULL;
								gchar* _tmp101_;
								FILE* _tmp102_;
								gchar* _tmp103_;
								_tmp95_ = app;
								_tmp96_ = _tmp95_->priv->gpaste;
								_tmp97_ = args;
								_tmp97__length1 = args_length1;
								_tmp98_ = _tmp97_[2];
								_tmp99_ = atoi (_tmp98_);
								_tmp100_ = gpaste_dbus_client_get_element (_tmp96_, (guint32) _tmp99_, &_inner_error_);
								_tmp101_ = _tmp100_;
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								_tmp102_ = stdout;
								_tmp103_ = _tmp101_;
								fprintf (_tmp102_, "%s", _tmp103_);
								_g_free0 (_tmp103_);
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label10) ? _tmp77_label10 : (_tmp77_label10 = g_quark_from_static_string ("s")))) || (_tmp78_ == ((0 != _tmp77_label11) ? _tmp77_label11 : (_tmp77_label11 = g_quark_from_static_string ("set"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp104_;
								GPasteDBusClient* _tmp105_;
								gchar** _tmp106_;
								gint _tmp106__length1;
								const gchar* _tmp107_;
								gint _tmp108_ = 0;
								_tmp104_ = app;
								_tmp105_ = _tmp104_->priv->gpaste;
								_tmp106_ = args;
								_tmp106__length1 = args_length1;
								_tmp107_ = _tmp106_[2];
								_tmp108_ = atoi (_tmp107_);
								gpaste_dbus_client_select (_tmp105_, (guint32) _tmp108_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label12) ? _tmp77_label12 : (_tmp77_label12 = g_quark_from_static_string ("d")))) || (_tmp78_ == ((0 != _tmp77_label13) ? _tmp77_label13 : (_tmp77_label13 = g_quark_from_static_string ("delete"))))) {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp109_;
								GPasteDBusClient* _tmp110_;
								gchar** _tmp111_;
								gint _tmp111__length1;
								const gchar* _tmp112_;
								gint _tmp113_ = 0;
								_tmp109_ = app;
								_tmp110_ = _tmp109_->priv->gpaste;
								_tmp111_ = args;
								_tmp111__length1 = args_length1;
								_tmp112_ = _tmp111_[2];
								_tmp113_ = atoi (_tmp112_);
								gpaste_dbus_client_delete (_tmp110_, (guint32) _tmp113_, &_inner_error_);
								if (_inner_error_ != NULL) {
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label14) ? _tmp77_label14 : (_tmp77_label14 = g_quark_from_static_string ("-f")))) || (_tmp78_ == ((0 != _tmp77_label15) ? _tmp77_label15 : (_tmp77_label15 = g_quark_from_static_string ("--file"))))) {
						switch (0) {
							default:
							{
								FILE* _tmp114_;
								const gchar* _tmp115_ = NULL;
								gchar** _tmp116_;
								gint _tmp116__length1;
								const gchar* _tmp117_;
								gchar** _tmp118_;
								gint _tmp118__length1;
								const gchar* _tmp119_;
								gchar** _tmp120_;
								gint _tmp120__length1;
								const gchar* _tmp121_;
								_tmp114_ = stderr;
								_tmp115_ = _ ("%s %s is deprecated: use \"%s file\" instead\n");
								_tmp116_ = args;
								_tmp116__length1 = args_length1;
								_tmp117_ = _tmp116_[0];
								_tmp118_ = args;
								_tmp118__length1 = args_length1;
								_tmp119_ = _tmp118_[1];
								_tmp120_ = args;
								_tmp120__length1 = args_length1;
								_tmp121_ = _tmp120_[0];
								fprintf (_tmp114_, _tmp115_, _tmp117_, _tmp119_, _tmp121_);
								break;
							}
						}
					} else if ((_tmp78_ == ((0 != _tmp77_label16) ? _tmp77_label16 : (_tmp77_label16 = g_quark_from_static_string ("f")))) || (_tmp78_ == ((0 != _tmp77_label17) ? _tmp77_label17 : (_tmp77_label17 = g_quark_from_static_string ("file"))))) {
						switch (0) {
							default:
							{
								gchar** _tmp122_;
								gint _tmp122__length1;
								const gchar* _tmp123_;
								GFile* _tmp124_ = NULL;
								GFile* file;
								_tmp122_ = args;
								_tmp122__length1 = args_length1;
								_tmp123_ = _tmp122_[2];
								_tmp124_ = g_file_new_for_path (_tmp123_);
								file = _tmp124_;
								{
									GFile* _tmp125_;
									GFileInputStream* _tmp126_ = NULL;
									GFileInputStream* _tmp127_;
									GFileInputStream* _tmp128_;
									GDataInputStream* _tmp129_;
									GDataInputStream* _tmp130_;
									GDataInputStream* dis;
									GString* _tmp131_;
									GString* text;
									GDataInputStream* _tmp132_;
									gchar* _tmp133_ = NULL;
									gchar* line;
									const gchar* _tmp134_;
									GPasteClientMain* _tmp144_;
									GPasteDBusClient* _tmp145_;
									GString* _tmp146_;
									const gchar* _tmp147_;
									_tmp125_ = file;
									_tmp126_ = g_file_read (_tmp125_, NULL, &_inner_error_);
									_tmp127_ = _tmp126_;
									if (_inner_error_ != NULL) {
										goto __catch3_g_error;
									}
									_tmp128_ = _tmp127_;
									_tmp129_ = g_data_input_stream_new (G_INPUT_STREAM (_tmp128_));
									_tmp130_ = _tmp129_;
									_g_object_unref0 (_tmp128_);
									dis = _tmp130_;
									_tmp131_ = g_string_new ("");
									text = _tmp131_;
									_tmp132_ = dis;
									_tmp133_ = g_data_input_stream_read_line (_tmp132_, NULL, NULL, &_inner_error_);
									line = _tmp133_;
									if (_inner_error_ != NULL) {
										_g_string_free0 (text);
										_g_object_unref0 (dis);
										goto __catch3_g_error;
									}
									_tmp134_ = line;
									if (_tmp134_ != NULL) {
										GString* _tmp135_;
										const gchar* _tmp136_;
										_tmp135_ = text;
										_tmp136_ = line;
										g_string_append (_tmp135_, (const gchar*) _tmp136_);
									}
									while (TRUE) {
										GDataInputStream* _tmp137_;
										gchar* _tmp138_ = NULL;
										gchar* _tmp139_;
										const gchar* _tmp140_;
										GString* _tmp141_;
										GString* _tmp142_ = NULL;
										const gchar* _tmp143_;
										_tmp137_ = dis;
										_tmp138_ = g_data_input_stream_read_line (_tmp137_, NULL, NULL, &_inner_error_);
										_tmp139_ = _tmp138_;
										if (_inner_error_ != NULL) {
											_g_free0 (line);
											_g_string_free0 (text);
											_g_object_unref0 (dis);
											goto __catch3_g_error;
										}
										_g_free0 (line);
										line = _tmp139_;
										_tmp140_ = line;
										if (!(_tmp140_ != NULL)) {
											break;
										}
										_tmp141_ = text;
										_tmp142_ = g_string_append_c (_tmp141_, '\n');
										_tmp143_ = line;
										g_string_append (_tmp142_, (const gchar*) _tmp143_);
									}
									_tmp144_ = app;
									_tmp145_ = _tmp144_->priv->gpaste;
									_tmp146_ = text;
									_tmp147_ = _tmp146_->str;
									gpaste_dbus_client_add (_tmp145_, _tmp147_, &_inner_error_);
									if (_inner_error_ != NULL) {
										_g_free0 (line);
										_g_string_free0 (text);
										_g_object_unref0 (dis);
										goto __catch3_g_error;
									}
									_g_free0 (line);
									_g_string_free0 (text);
									_g_object_unref0 (dis);
								}
								goto __finally3;
								__catch3_g_error:
								{
									GError* e = NULL;
									FILE* _tmp148_;
									const gchar* _tmp149_ = NULL;
									gchar** _tmp150_;
									gint _tmp150__length1;
									const gchar* _tmp151_;
									e = _inner_error_;
									_inner_error_ = NULL;
									_tmp148_ = stderr;
									_tmp149_ = _ ("Could not read file: %s\n");
									_tmp150_ = args;
									_tmp150__length1 = args_length1;
									_tmp151_ = _tmp150_[2];
									fprintf (_tmp148_, _tmp149_, _tmp151_);
									_g_error_free0 (e);
								}
								__finally3:
								if (_inner_error_ != NULL) {
									_g_object_unref0 (file);
									if (_inner_error_->domain == G_IO_ERROR) {
										goto __catch0_g_io_error;
									}
									_g_object_unref0 (file);
									_g_object_unref0 (app);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return 0;
								}
								_g_object_unref0 (file);
								break;
							}
						}
					} else {
						switch (0) {
							default:
							{
								GPasteClientMain* _tmp152_;
								gchar** _tmp153_;
								gint _tmp153__length1;
								const gchar* _tmp154_;
								_tmp152_ = app;
								_tmp153_ = args;
								_tmp153__length1 = args_length1;
								_tmp154_ = _tmp153_[0];
								gpaste_client_main_usage (_tmp152_, _tmp154_);
								result = 1;
								_g_object_unref0 (app);
								return result;
							}
						}
					}
					break;
				}
				default:
				{
					GPasteClientMain* _tmp155_;
					gchar** _tmp156_;
					gint _tmp156__length1;
					const gchar* _tmp157_;
					_tmp155_ = app;
					_tmp156_ = args;
					_tmp156__length1 = args_length1;
					_tmp157_ = _tmp156_[0];
					gpaste_client_main_usage (_tmp155_, _tmp157_);
					result = 1;
					_g_object_unref0 (app);
					return result;
				}
			}
		}
		result = 0;
		_g_object_unref0 (app);
		return result;
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		gchar** _tmp158_;
		gint _tmp158__length1;
		FILE* _tmp167_;
		const gchar* _tmp168_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp158_ = args;
		_tmp158__length1 = args_length1;
		if (_tmp158__length1 == 2) {
			gchar** _tmp159_;
			gint _tmp159__length1;
			const gchar* _tmp160_;
			const gchar* _tmp161_;
			GQuark _tmp163_ = 0U;
			static GQuark _tmp162_label0 = 0;
			static GQuark _tmp162_label1 = 0;
			static GQuark _tmp162_label2 = 0;
			_tmp159_ = args;
			_tmp159__length1 = args_length1;
			_tmp160_ = _tmp159_[1];
			_tmp161_ = _tmp160_;
			_tmp163_ = (NULL == _tmp161_) ? 0 : g_quark_from_string (_tmp161_);
			if (((_tmp163_ == ((0 != _tmp162_label0) ? _tmp162_label0 : (_tmp162_label0 = g_quark_from_static_string ("help")))) || (_tmp163_ == ((0 != _tmp162_label1) ? _tmp162_label1 : (_tmp162_label1 = g_quark_from_static_string ("-h"))))) || (_tmp163_ == ((0 != _tmp162_label2) ? _tmp162_label2 : (_tmp162_label2 = g_quark_from_static_string ("--help"))))) {
				switch (0) {
					default:
					{
						GPasteClientMain* _tmp164_;
						gchar** _tmp165_;
						gint _tmp165__length1;
						const gchar* _tmp166_;
						_tmp164_ = app;
						_tmp165_ = args;
						_tmp165__length1 = args_length1;
						_tmp166_ = _tmp165_[0];
						gpaste_client_main_usage (_tmp164_, _tmp166_);
						break;
					}
				}
			} else {
				switch (0) {
					default:
					{
						break;
					}
				}
			}
			result = 0;
			_g_error_free0 (e);
			_g_object_unref0 (app);
			return result;
		}
		_tmp167_ = stderr;
		_tmp168_ = _ ("Couldn't connect to GPaste daemon.\n");
		fprintf (_tmp167_, "%s", _tmp168_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app);
		return result;
	}
	__finally0:
	_g_object_unref0 (app);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return 0;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gpaste_client_main_main (argv, argc);
}


GPasteClientMain* gpaste_client_main_construct (GType object_type) {
	GPasteClientMain * self = NULL;
	self = (GPasteClientMain*) g_object_new (object_type, NULL);
	return self;
}


GPasteClientMain* gpaste_client_main_new (void) {
	return gpaste_client_main_construct (GPASTE_CLIENT_TYPE_MAIN);
}


static void gpaste_client_main_class_init (GPasteClientMainClass * klass) {
	gpaste_client_main_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteClientMainPrivate));
	G_OBJECT_CLASS (klass)->finalize = gpaste_client_main_finalize;
}


static void gpaste_client_main_instance_init (GPasteClientMain * self) {
	self->priv = GPASTE_CLIENT_MAIN_GET_PRIVATE (self);
}


static void gpaste_client_main_finalize (GObject* obj) {
	GPasteClientMain * self;
	self = GPASTE_CLIENT_MAIN (obj);
	_g_object_unref0 (self->priv->gpaste);
	G_OBJECT_CLASS (gpaste_client_main_parent_class)->finalize (obj);
}


GType gpaste_client_main_get_type (void) {
	static volatile gsize gpaste_client_main_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_client_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteClientMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_client_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteClientMain), 0, (GInstanceInitFunc) gpaste_client_main_instance_init, NULL };
		GType gpaste_client_main_type_id;
		gpaste_client_main_type_id = g_type_register_static (G_TYPE_OBJECT, "GPasteClientMain", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_client_main_type_id__volatile, gpaste_client_main_type_id);
	}
	return gpaste_client_main_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



